var _excluded = ["name", "fieldProps"],
    _excluded2 = ["input", "meta", "options", "label", "required", "multiple", "textFieldProps", "getOptionValue", "getOptionSelected", "showError", "placeholder", "onChange"],
    _excluded3 = ["helperText"],
    _excluded4 = ["variant"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/*
*SOURCE: https://github.com/lookfirst/mui-rff/blob/master/src/Autocomplete.tsx
This should be removed and the native one used ASAP this issues is fixed: https://github.com/lookfirst/mui-rff/issues/308
*/
import TextField from '@mui/material/TextField';
import { Autocomplete as MuiAutocomplete } from '@mui/material';
import React from 'react';
import { Field } from 'react-final-form';
import { showErrorOnChange } from './Util';
export function Autocomplete(props) {
  var name = props.name,
      fieldProps = props.fieldProps,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return React.createElement(Field, Object.assign({
    name: name,
    render: function render(fieldRenderProps) {
      return React.createElement(AutocompleteWrapper, Object.assign({}, fieldRenderProps, rest));
    }
  }, fieldProps));
}

function AutocompleteWrapper(props) {
  var _props$input = props.input,
      name = _props$input.name,
      onChange = _props$input.onChange,
      value = _props$input.value,
      meta = props.meta,
      options = props.options,
      label = props.label,
      required = props.required,
      multiple = props.multiple,
      textFieldProps = props.textFieldProps,
      getOptionValue = props.getOptionValue,
      getOptionSelected = props.getOptionSelected,
      _props$showError = props.showError,
      showError = _props$showError === void 0 ? showErrorOnChange : _props$showError,
      placeholder = props.placeholder,
      onChangeCallback = props.onChange,
      rest = _objectWithoutPropertiesLoose(props, _excluded2);

  function getValue(values) {
    if (!getOptionValue) {
      return values;
    } // ternary hell...


    return multiple ? values ? values.map(getOptionValue) : null : values ? getOptionValue(values) : null;
  }

  var helperText = rest.helperText,
      lessrest = _objectWithoutPropertiesLoose(rest, _excluded3);

  var _ref = textFieldProps || {},
      variant = _ref.variant,
      restTextFieldProps = _objectWithoutPropertiesLoose(_ref, _excluded4); // yuck...


  var defaultValue = null;

  if (!getOptionValue) {
    defaultValue = value;
  } else if (value) {
    options.forEach(function (option) {
      var optionValue = getOptionValue(option);

      if (multiple) {
        if (!defaultValue) {
          defaultValue = [];
        }

        value.forEach(function (v) {
          if (getOptionSelected(optionValue, v)) {
            defaultValue.push(option);
          }
        });
      } else {
        if (getOptionSelected(optionValue, value)) {
          defaultValue = option;
        }
      }
    });
  } //defaultValue = getValue(value)


  var onChangeFunc = function onChangeFunc(event, value, reason, details) {
    var gotValue = getValue(value);
    onChange(gotValue);

    if (onChangeCallback) {
      onChangeCallback(event, value, reason, details);
    }
  };

  var error = meta.error,
      submitError = meta.submitError;
  var isError = showError({
    meta: meta
  });
  return React.createElement(MuiAutocomplete, Object.assign({
    multiple: multiple,
    onChange: onChangeFunc,
    options: options,
    value: defaultValue,
    renderInput: function renderInput(params) {
      return React.createElement(TextField, Object.assign({
        label: label,
        required: required,
        helperText: isError ? error || submitError : helperText,
        error: isError,
        name: name,
        placeholder: placeholder,
        variant: variant
      }, params, restTextFieldProps, {
        fullWidth: true,
        value: value
      }));
    }
  }, lessrest));
}