var _excluded = ["name", "type", "fieldProps", "path"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState } from "react";
import { Box, TextField as MuiTextField } from "@mui/material";
import Fab from "@mui/material/Fab";
import Camera from "@mui/icons-material/CameraAlt";
import { showErrorOnChange } from "./Util";
import { Field } from "react-final-form";
import Avatar from "@mui/material/Avatar";
import ImgageUploadDialog from "../../containers/ImageUploadDialog";
export function AvatarImage(props) {
  var _useState = useState(false),
      isImageDialogOpen = _useState[0],
      setImageDialogOpen = _useState[1];

  var name = props.name,
      type = props.type,
      fieldProps = props.fieldProps,
      path = props.path,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return /*#__PURE__*/React.createElement(Field, _extends({
    name: name,
    type: type,
    render: function render(_ref) {
      var input = _ref.input,
          meta = _ref.meta;
      var value = input.value,
          onChange = input.onChange;

      var handleImageChange = function handleImageChange(image) {
        onChange(image);
      };

      return /*#__PURE__*/React.createElement("div", {
        style: {
          display: "flex",
          flexDirection: "column",
          justifyContent: "center",
          alignItems: "center"
        }
      }, /*#__PURE__*/React.createElement(Avatar, {
        style: {
          minWidth: 100,
          minHeight: 100
        },
        alt: "Picture",
        src: value
      }), /*#__PURE__*/React.createElement(Box, {
        sx: {
          margin: 1
        }
      }, /*#__PURE__*/React.createElement(Fab, {
        onClick: function onClick() {
          return setImageDialogOpen(true);
        },
        style: {},
        color: "primary",
        "aria-label": "save",
        size: "small"
      }, /*#__PURE__*/React.createElement(Camera, null))), /*#__PURE__*/React.createElement(ImgageUploadDialog, {
        isOpen: isImageDialogOpen,
        handleClose: function handleClose() {
          return setImageDialogOpen(false);
        },
        handleCropSubmit: handleImageChange,
        path: path
      }));
    }
  }, fieldProps));
}