var _excluded = ["name", "fieldProps"],
    _excluded2 = ["name", "onChange", "value"],
    _excluded3 = ["input", "formatValue", "meta", "dateFunsUtils", "locale", "showError"],
    _excluded4 = ["helperText"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import { DatePicker } from "@mui/x-date-pickers";
import { Field } from "react-final-form";
import { showErrorOnChange } from "./Util";
import TextField from "@mui/material/TextField";
export function KeyboardDatePicker(props) {
  var name = props.name,
      fieldProps = props.fieldProps,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return React.createElement(Field, Object.assign({
    name: name,
    render: function render(fieldRenderProps) {
      return React.createElement(KeyboardDatePickerWrapper, Object.assign({}, fieldRenderProps, rest));
    }
  }, fieldProps));
}

function KeyboardDatePickerWrapper(props) {
  var _props$input = props.input,
      name = _props$input.name,
      _onChange = _props$input.onChange,
      value = _props$input.value,
      restInput = _objectWithoutPropertiesLoose(_props$input, _excluded2),
      _props$formatValue = props.formatValue,
      formatValue = _props$formatValue === void 0 ? function (v) {
    if (v && v.isValid()) {
      return v.format();
    } else {
      return null; //v?._i
    }
  } : _props$formatValue,
      meta = props.meta,
      dateFunsUtils = props.dateFunsUtils,
      locale = props.locale,
      _props$showError = props.showError,
      showError = _props$showError === void 0 ? showErrorOnChange : _props$showError,
      rest = _objectWithoutPropertiesLoose(props, _excluded3);

  var error = meta.error,
      submitError = meta.submitError;
  var isError = showError({
    meta: meta
  });

  var helperText = rest.helperText,
      lessrest = _objectWithoutPropertiesLoose(rest, _excluded4);

  return React.createElement(DatePicker, Object.assign({
    disableToolbar: true,
    fullWidth: true,
    autoOk: true,
    helperText: isError ? error || submitError : helperText,
    error: isError,
    onChange: function onChange(v) {
      _onChange(formatValue(v));
    },
    name: name,
    value: value === "" ? null : value,
    inputProps: restInput,
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React.createElement(TextField, params);
    }
  }, lessrest)), locale;
}