import React from 'react';
import { makeStyles } from '@mui/styles';
import { useSnackbar, SnackbarContent } from 'notistack';
import CloseIcon from '@mui/icons-material/Close';
import { Avatar, CardMedia, IconButton, Card, CardHeader } from '@mui/material';
import Notifications from '@mui/icons-material/Notifications';
import { useNavigate } from 'react-router-dom';
import { ThemeProvider } from '@mui/styles';
import { createTheme } from '@mui/material/styles';
import { useTheme as useAppTheme } from 'material-ui-shell/lib/providers/Theme';
var useStyles = makeStyles(function (theme) {
  var _root;

  return {
    root: (_root = {}, _root[theme.breakpoints.up('sm')] = {
      minWidth: '344px !important'
    }, _root.maxWidth = 400, _root.cursor = 'pointer', _root),
    card: {
      width: '100%'
    }
  };
});
var SnackMessage = React.forwardRef(function (props, ref) {
  var classes = useStyles();
  var navigate = useNavigate();

  var _useSnackbar = useSnackbar(),
      closeSnackbar = _useSnackbar.closeSnackbar;

  var payload = props.payload,
      id = props.id;
  var notification = payload.notification;

  var _ref = notification || {},
      title = _ref.title,
      body = _ref.body,
      icon = _ref.icon,
      image = _ref.image,
      click_action = _ref.click_action; // const theme = useTheme()
  // const type = theme.palette.type === 'light' ? 'dark' : 'light'


  var _useAppTheme = useAppTheme(),
      isDarkMode = _useAppTheme.isDarkMode;

  var innerTheme = createTheme({
    palette: {
      type: isDarkMode ? 'light' : 'dark'
    }
  });

  var handleDismiss = function handleDismiss() {
    closeSnackbar(id);
  };

  var handleClick = function handleClick() {
    var url = new URL(click_action);
    navigate(url.pathname);
    handleDismiss();
  };

  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: innerTheme
  }, /*#__PURE__*/React.createElement(SnackbarContent, {
    ref: ref,
    className: classes.root
  }, /*#__PURE__*/React.createElement(Card, {
    className: classes.card
  }, image && /*#__PURE__*/React.createElement(CardMedia, {
    onClick: handleClick,
    style: {
      height: 140
    },
    image: image,
    title: title
  }), /*#__PURE__*/React.createElement(CardHeader, {
    avatar: /*#__PURE__*/React.createElement(Avatar, {
      onClick: handleClick,
      src: icon,
      "aria-label": "recipe"
    }, /*#__PURE__*/React.createElement(Notifications, null)),
    action: /*#__PURE__*/React.createElement(IconButton, {
      onClick: handleDismiss,
      style: {
        zIndex: 9999
      },
      className: classes.expand
    }, /*#__PURE__*/React.createElement(CloseIcon, null)),
    title: /*#__PURE__*/React.createElement("div", {
      onClick: handleClick
    }, title),
    subheader: /*#__PURE__*/React.createElement("div", {
      onClick: handleClick
    }, body)
  }))));
});
export default SnackMessage;