function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from "react";
import ListItem from "@mui/material/ListItem";
import ListItemText from "@mui/material/ListItemText";
import Divider from "@mui/material/Divider";
import Avatar from "@mui/material/Avatar";
import Mail from "@mui/icons-material/Mail";
import Star from "@mui/icons-material/Star";
import ListItemAvatar from "@mui/material/ListItemAvatar";
import { GoogleIcon, FacebookIcon, GitHubIcon, TwitterIcon } from "../../components/Icons";
import Badge from "@mui/material/Badge";
import ListItemSecondaryAction from "@mui/material/ListItemSecondaryAction";
import Checkbox from "@mui/material/Checkbox";

var getProviderIcon = function getProviderIcon(id) {
  var iconProps = {
    color: "primary",
    style: {
      height: 20,
      width: 20
    }
  };

  if (id === "google.com") {
    return /*#__PURE__*/React.createElement(GoogleIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "facebook.com") {
    return /*#__PURE__*/React.createElement(FacebookIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "github.com") {
    return /*#__PURE__*/React.createElement(GitHubIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "twitter.com") {
    return /*#__PURE__*/React.createElement(TwitterIcon, _extends({
      key: id
    }, iconProps));
  }

  return /*#__PURE__*/React.createElement(Mail, _extends({
    key: id
  }, iconProps));
};

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style,
      _ref$admins = _ref.admins,
      admins = _ref$admins === void 0 ? [] : _ref$admins,
      _ref$isChecked = _ref.isChecked,
      isChecked = _ref$isChecked === void 0 ? false : _ref$isChecked,
      _ref$handleRowClick = _ref.handleRowClick,
      handleRowClick = _ref$handleRowClick === void 0 ? function () {} : _ref$handleRowClick,
      _ref$hasCheckbox = _ref.hasCheckbox,
      hasCheckbox = _ref$hasCheckbox === void 0 ? false : _ref$hasCheckbox;
  var _data$displayName = data.displayName,
      displayName = _data$displayName === void 0 ? "" : _data$displayName,
      key = data.key,
      photoURL = data.photoURL,
      _data$providerData = data.providerData,
      providerData = _data$providerData === void 0 ? [] : _data$providerData,
      icon = data.icon,
      secondaryText = data.secondaryText;
  var isAdmin = false;
  admins.map(function (a) {
    if (a.key === key) {
      isAdmin = true;
    }

    return a;
  });
  return /*#__PURE__*/React.createElement("div", {
    key: key,
    style: style
  }, /*#__PURE__*/React.createElement(ListItem, {
    button: true,
    alignItems: "flex-start",
    style: {
      height: 82
    },
    onClick: function onClick() {
      return handleRowClick(data);
    }
  }, /*#__PURE__*/React.createElement(ListItemAvatar, null, /*#__PURE__*/React.createElement(Badge, {
    invisible: !isAdmin,
    anchorOrigin: {
      vertical: "top",
      horizontal: "left"
    },
    badgeContent: /*#__PURE__*/React.createElement(Star, {
      style: {
        width: 15,
        padding: 0
      }
    }),
    color: "secondary"
  }, /*#__PURE__*/React.createElement(Avatar, {
    src: photoURL,
    style: {
      height: 45,
      width: 45
    }
  }, icon))), /*#__PURE__*/React.createElement(ListItemText, {
    primary: "" + displayName,
    secondary: providerData.length > 0 ? /*#__PURE__*/React.createElement(React.Fragment, null, providerData.map(function (p) {
      return getProviderIcon(p.providerId);
    })) : secondaryText
  }), hasCheckbox && /*#__PURE__*/React.createElement(ListItemSecondaryAction, null, /*#__PURE__*/React.createElement(Checkbox, {
    edge: "end",
    checked: !!isChecked,
    onClick: function onClick() {
      return handleRowClick(data);
    }
  }))), /*#__PURE__*/React.createElement(Divider, {
    variant: "inset"
  }));
};

export default Row;