import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React, { useEffect, useCallback } from 'react';
import { useIntl } from 'react-intl';
import * as firebaseui from 'firebaseui';
import { getAuth } from 'firebase/auth';
var authUi = null;
/*eslint-disable */

var AuthUI = function AuthUI(_ref) {
  var uiConfig = _ref.uiConfig;
  var intl = useIntl();
  var locale = intl.locale;
  var auth = getAuth();
  var initAuth = useCallback( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            try {
              if (!firebaseui.auth.AuthUI.getInstance()) {
                authUi = new firebaseui.auth.AuthUI(auth);
              } else {
                authUi = firebaseui.auth.AuthUI.getInstance();
              }
            } catch (err) {
              console.warn(err);
            }

            try {
              authUi.start('#firebaseui-auth', uiConfig);
            } catch (error) {
              console.warn(error);
            }

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), [locale]);
  useEffect(function () {
    initAuth();
    return function () {
      try {
        if (authUi) {
          authUi.reset();
        }
      } catch (err) {
        console.warn(err);
      }
    };
  }, [initAuth, authUi]);
  return /*#__PURE__*/React.createElement("div", {
    style: {
      paddingTop: 35
    }
  }, /*#__PURE__*/React.createElement("div", {
    key: "" + intl.locale,
    id: "firebaseui-auth"
  }));
};

export default AuthUI;
/*eslint-enable */