import _regeneratorRuntime from "@babel/runtime/regenerator";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React, { useState } from "react";
import Input from "@mui/material/Input";
import { useTheme } from "@mui/material/styles";
import Fab from "@mui/material/Fab";
import Mic from "@mui/icons-material/Mic";
import MyLocation from "@mui/icons-material/MyLocation";
import CameraAlt from "@mui/icons-material/CameraAlt";
import Send from "@mui/icons-material/Send";
import { useIntl } from "react-intl";
import IconButton from "@mui/material/IconButton";
import { useAuth } from "base-shell/lib/providers/Auth";
import { getLocation } from "../../utils/location";
import { CircularProgress } from "@mui/material";
import { getDatabase, ref, set, push, serverTimestamp } from "firebase/database";
import { getStorage, ref as storageRef, uploadString, getDownloadURL } from "firebase/storage";
import { getApp } from "firebase/app";
export default function (_ref) {
  var path = _ref.path;
  var theme = useTheme();
  var intl = useIntl();

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _useState = useState(""),
      value = _useState[0],
      setValue = _useState[1];

  var _useState2 = useState(false),
      isUploading = _useState2[0],
      setUploading = _useState2[1];

  var db = getDatabase();

  var uploadSelectedFile = function uploadSelectedFile(file) {
    if (file === null) {
      return;
    }

    if ((file.size / 1024 / 1024).toFixed(4) > 20) {
      //file larger than 10mb
      alert(intl.formatMessage({
        id: "max_file_size"
      }));
      return;
    }

    setUploading(true);
    var reader = new FileReader();
    var r = push(ref(db, "/user_chat_messages/"));

    reader.onload = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(fileData) {
        var snap, downloadURL;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return uploadString(storageRef(getStorage(getApp()), "/user_chats/" + auth.uid + "/" + r.key + ".jpg"), fileData.target.result, "data_url");

              case 2:
                snap = _context.sent;
                _context.next = 5;
                return getDownloadURL(snap.ref);

              case 5:
                downloadURL = _context.sent;
                sendMessage({
                  type: "image",
                  message: "",
                  image: downloadURL,
                  key: r.key
                });
                setUploading(false);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }();

    reader.readAsDataURL(file);
  };

  var sendMessage = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(props) {
      var newMessage;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              newMessage = _extends({
                created: serverTimestamp(),
                authorName: auth.displayName,
                authorUid: auth.uid,
                authorPhotoUrl: auth.photoURL,
                languageCode: intl.formatMessage({
                  id: "current_locale",
                  defaultMessage: "en-US"
                })
              }, props);
              console.log("path", path);
              console.log("newMessage", newMessage);
              _context2.next = 5;
              return set(push(ref(db, "" + path)), newMessage);

            case 5:
              setValue("");

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function sendMessage(_x2) {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement("div", {
    style: {
      display: "flex",
      padding: 4,
      paddingBottom: 8,
      alignItems: "center"
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      margin: 0,
      marginLeft: 8,
      marginRight: 8,
      paddingRight: 8,
      backgroundColor: theme.palette.grey[300],
      borderRadius: 22,
      height: "100%",
      flex: 1,
      display: "flex"
    }
  }, /*#__PURE__*/React.createElement(Input, {
    style: {
      height: 50,
      left: 15,
      color: "black"
    },
    multiline: true,
    rowsMax: "2",
    disableUnderline: true,
    fullWidth: true,
    autoFocus: true,
    value: value,
    autoComplete: "off",
    placeholder: intl.formatMessage({
      id: "write_message_hint",
      defaultMessage: "Write message"
    }),
    onChange: function onChange(e) {
      return setValue(e.target.value);
    },
    onKeyDown: function onKeyDown(e) {
      if (e.keyCode === 13 && value.trim() !== "") {
        e.preventDefault();
        sendMessage({
          type: "text",
          message: value
        });
      }
    },
    type: "Text"
  }), /*#__PURE__*/React.createElement("input", {
    style: {
      display: "none"
    },
    accept: "image/*",
    id: "icon-button-file",
    type: "file",
    onChange: function onChange(e) {
      uploadSelectedFile(e.target.files[0]);
    }
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      display: "flex",
      alignItems: "center",
      justifyContent: "center"
    }
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
    htmlFor: "icon-button-file"
  }, /*#__PURE__*/React.createElement(IconButton, {
    disabled: isUploading,
    color: "primary",
    "aria-label": "upload picture",
    component: "span",
    size: "small",
    edge: false
  }, isUploading && /*#__PURE__*/React.createElement(CircularProgress, {
    color: "secondary",
    style: {
      width: 20,
      height: 20
    }
  }), !isUploading && /*#__PURE__*/React.createElement(CameraAlt, null))))), /*#__PURE__*/React.createElement(IconButton, {
    color: "primary",
    size: "small",
    onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      var _yield$getLocation, coords, lat, _long;

      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return getLocation();

            case 3:
              _yield$getLocation = _context3.sent;
              coords = _yield$getLocation.coords;
              lat = coords === null || coords === void 0 ? void 0 : coords.latitude;
              _long = coords === null || coords === void 0 ? void 0 : coords.longitude;
              sendMessage({
                type: "location",
                message: "",
                location: "https://www.google.com/maps/place/" + lat + "+" + _long + "/@" + lat + "," + _long,
                location_lat: lat,
                location_lng: _long
              });
              _context3.next = 12;
              break;

            case 10:
              _context3.prev = 10;
              _context3.t0 = _context3["catch"](0);

            case 12:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[0, 10]]);
    }))
  }, /*#__PURE__*/React.createElement(MyLocation, null))), /*#__PURE__*/React.createElement(Fab, {
    onClick: value !== "" ? function () {
      return sendMessage({
        type: "text",
        message: value
      });
    } : undefined,
    color: "secondary",
    size: "medium"
  }, value === "" && /*#__PURE__*/React.createElement(Mic, null), value !== "" && /*#__PURE__*/React.createElement(Send, null)));
}