function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useCallback, useEffect, useState } from 'react';
import { useLists } from '../../providers/Firebase/Lists';
import ChatMessage from '../../components/ChatMessage';
import Input from './Input';
import Chip from '@mui/material/Chip';
import Scrollbar from 'material-ui-shell/lib/components/Scrollbar';
import { useTheme } from '@mui/material/styles';
import ChatIcon from '@mui/icons-material/Chat';
import { useIntl } from 'react-intl';
import { getDatabase, ref, query, orderByKey, limitToLast } from 'firebase/database';
var step = 20;
var currentUser = null;
var currentDate = null;
export default function (_ref) {
  var path = _ref.path;
  var intl = useIntl();
  var theme = useTheme();

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      unwatchList = _useLists.unwatchList,
      clearList = _useLists.clearList;

  var _useState = useState(step),
      size = _useState[0],
      setSize = _useState[1];

  var _useState2 = useState(null),
      listEnd = _useState2[0],
      setlistEnd = _useState2[1];

  var alias = path + "_" + size;
  var messages = getList(alias);
  var scrollToBottom = useCallback(function () {
    if (size === step) {
      var node = listEnd;

      if (node) {
        node.scrollIntoView({
          behavior: 'smooth'
        });
      }
    }
  }, [listEnd, size]);
  useEffect(function () {
    if (path) {
      var messagesRef = query(ref(getDatabase(), path), orderByKey(), limitToLast(size));
      watchList(messagesRef, alias);
      return function () {
        if (size === step) {
          unwatchList(alias);
        } else {
          clearList(alias);
        }
      };
    }
  }, [path, size, watchList, clearList, alias, unwatchList]);
  useEffect(function () {
    scrollToBottom();
    setTimeout(function () {
      scrollToBottom();
    }, 1000);
  }, [path, listEnd, messages, scrollToBottom]);

  if (!path) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        height: '100%',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center'
      }
    }, /*#__PURE__*/React.createElement(ChatIcon, {
      color: "disabled",
      style: {
        height: 150,
        width: 150
      }
    }));
  }

  return /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      flexGrow: 1,
      overflow: 'hidden'
    }
  }, /*#__PURE__*/React.createElement(Scrollbar, {
    style: {
      //backgroundColor: theme.palette.background.default,
      width: '100%'
    },
    renderView: function renderView(props) {
      return /*#__PURE__*/React.createElement("div", _extends({}, props, {
        style: _extends({}, props.style, {
          overflowX: 'hidden'
        })
      }));
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      paddingLeft: 8,
      paddingRight: 8
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      width: '100%',
      maxWidth: 500
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: 15
    }
  }), /*#__PURE__*/React.createElement(Chip, {
    label: intl.formatMessage({
      id: 'load_more_label',
      defaultMessage: 'more...'
    }),
    onClick: function onClick() {
      setSize(size + step);
    },
    size: "small",
    style: {
      width: 80,
      alignSelf: 'center',
      margin: 8,
      backgroundColor: theme.palette.grey[400]
    }
  }), messages.map(function (m) {
    var _ref2 = (m === null || m === void 0 ? void 0 : m.val) || {},
        _ref2$authorUid = _ref2.authorUid,
        authorUid = _ref2$authorUid === void 0 ? '' : _ref2$authorUid,
        _ref2$created = _ref2.created,
        created = _ref2$created === void 0 ? '' : _ref2$created;

    var stringDate = created ? new Date(created).toISOString().slice(0, 10) : '';
    var userChanged = authorUid !== currentUser;
    var dateChanged = currentDate !== stringDate;

    if (userChanged) {
      currentUser = authorUid;
    }

    if (dateChanged) {
      currentDate = stringDate;
    }

    return /*#__PURE__*/React.createElement(ChatMessage, {
      key: m.key,
      uid: m.key,
      message: m,
      path: path,
      userChanged: userChanged,
      dateChanged: dateChanged,
      scrollToBottom: scrollToBottom
    });
  }))), /*#__PURE__*/React.createElement("div", {
    style: {
      "float": 'left',
      clear: 'both'
    },
    ref: function ref(el) {
      setlistEnd(el);
    }
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      height: 8
    }
  }))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Input, {
    path: path
  })));
}