import React, { useEffect } from "react";
import { useConfig } from "base-shell/lib/providers/Config";
import { useAuth } from "base-shell/lib/providers/Auth";
import PathsProvider from "../../providers/Firebase/Paths/Provider";
import ListsProvider from "../../providers/Firebase/Lists/Provider";
import DocsProvider from "../../providers/Firebase/Docs/Provider";
import ColsProvider from "../../providers/Firebase/Cols/Provider";
import MessagingProvider from "../../providers/Firebase/Messaging/Provider";
import StorageProvider from "../../providers/Firebase/Storage/Provider";
import { initializeApp, getApps, getApp } from "firebase/app";
import { getAuth, onAuthStateChanged } from "firebase/auth";
import { LocalizationProvider } from "@mui/x-date-pickers/LocalizationProvider";
import { AdapterMoment as DateAdapter } from "@mui/x-date-pickers/AdapterMoment";
import { useLocale } from "base-shell/lib/providers/Locale";
export default function (_ref) {
  var children = _ref.children;

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var auth = useAuth();

  var _ref2 = appConfig || {},
      firebaseConfig = _ref2.firebase,
      _ref2$auth = _ref2.auth,
      authConfig = _ref2$auth === void 0 ? {} : _ref2$auth;

  var _ref3 = firebaseConfig || {},
      _ref3$prod = _ref3.prod,
      prod = _ref3$prod === void 0 ? {} : _ref3$prod,
      _ref3$dev = _ref3.dev,
      dev = _ref3$dev === void 0 ? {} : _ref3$dev;

  var _ref4 = authConfig || {},
      internalOnAuthStateChanged = _ref4.onAuthStateChanged;

  var _useLocale = useLocale(),
      _useLocale$locale = _useLocale.locale,
      locale = _useLocale$locale === void 0 ? "en" : _useLocale$locale;

  if (getApps().length === 0) {
    initializeApp(process.env.NODE_ENV !== "production" ? dev.initConfig : prod.initConfig);
  }

  useEffect(function () {
    var unsubscribe = onAuthStateChanged(getAuth(getApp()), function (user) {
      if (onAuthStateChanged) {
        internalOnAuthStateChanged(user, auth);
      }
    });
    return function () {
      unsubscribe();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/React.createElement(PathsProvider, null, /*#__PURE__*/React.createElement(ListsProvider, null, /*#__PURE__*/React.createElement(DocsProvider, null, /*#__PURE__*/React.createElement(ColsProvider, null, /*#__PURE__*/React.createElement(StorageProvider, null, /*#__PURE__*/React.createElement(MessagingProvider, null, /*#__PURE__*/React.createElement(LocalizationProvider, {
    dateAdapter: DateAdapter,
    adapterLocale: locale
  }, children)))))));
}