import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import Checkbox from '@mui/material/Checkbox';
import Divider from '@mui/material/Divider';
import ListItem from '@mui/material/ListItem';
import ListItemIcon from '@mui/material/ListItemIcon';
import ListItemText from '@mui/material/ListItemText';
import React, { useEffect } from 'react';
import VirtualList from 'material-ui-shell/lib/containers/VirtualList';
import { useConfig } from 'base-shell/lib/providers/Config';
import { useFilter } from 'material-ui-shell/lib/providers/Filter';
import { useLists } from '../../providers/Firebase/Lists';
import { getDatabase, ref, set } from 'firebase/database';
export default function (_ref) {
  var grantsPath = _ref.grantsPath;

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var _ref2 = appConfig || {},
      authConfig = _ref2.auth;

  var _ref3 = authConfig || {},
      _ref3$grants = _ref3.grants,
      grants = _ref3$grants === void 0 ? [] : _ref3$grants;

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getFirebaseList = _useLists.getList;

  var _useFilter = useFilter(),
      getList = _useFilter.getList;

  var db = getDatabase();
  var roleGrants = getFirebaseList(grantsPath);
  var list = getList('grants', grants.map(function (g) {
    return {
      name: g
    };
  }), [{
    name: 'name'
  }]);
  useEffect(function () {
    watchList(grantsPath);
  }, [grantsPath, watchList]);

  var Row = function Row(_ref4) {
    var index = _ref4.index,
        style = _ref4.style,
        data = _ref4.data;
    var name = data.name;
    var isSelected = false;
    roleGrants.map(function (rg) {
      if (rg.key === name) {
        isSelected = true;
      }

      return rg;
    });
    return /*#__PURE__*/React.createElement("div", {
      key: name + "_" + index,
      style: style
    }, /*#__PURE__*/React.createElement(ListItem, {
      button: true,
      alignItems: "flex-start",
      onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return set(ref(db, grantsPath + "/" + name), isSelected ? null : true);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))
    }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(Checkbox, {
      edge: "start",
      checked: isSelected,
      tabIndex: -1,
      disableRipple: true
    })), /*#__PURE__*/React.createElement(ListItemText, {
      primary: name,
      secondary: name
    })), /*#__PURE__*/React.createElement(Divider, null));
  };

  return /*#__PURE__*/React.createElement(VirtualList, {
    list: list,
    name: "grants",
    listProps: {
      itemSize: 72
    },
    Row: Row
  });
}