var _excluded = ["src"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import Backdrop from '@mui/material/Backdrop';
import Fade from '@mui/material/Fade'; //import Image from 'material-ui-image'

import Modal from '@mui/material/Modal';
import React, { useState } from 'react';
import Fab from '@mui/material/Fab';
import CloseIcon from '@mui/icons-material/Close';
import Slide from '@mui/material/Slide';

var ImageViewer = function ImageViewer(_ref) {
  var src = _ref.src,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      open = _useState[0],
      setOpen = _useState[1];

  var handleOpen = function handleOpen() {
    setOpen(true);
  };

  var handleClose = function handleClose() {
    setOpen(false);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", _extends({
    src: src,
    onClick: handleOpen
  }, rest)), /*#__PURE__*/React.createElement(Modal, {
    "aria-labelledby": "transition-modal-title",
    "aria-describedby": "transition-modal-description",
    open: open,
    onClose: handleClose,
    onEscapeKeyDown: handleClose,
    closeAfterTransition: true,
    BackdropComponent: Backdrop,
    BackdropProps: {
      timeout: 500
    },
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React.createElement(Fade, {
    "in": open
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      maxHeight: '70%',
      maxWidth: '90%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      top: 50,
      left: 0,
      right: 0,
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      zIndex: 9999999
    }
  }, /*#__PURE__*/React.createElement(Slide, {
    direction: "down",
    "in": open,
    mountOnEnter: true,
    unmountOnExit: true
  }, /*#__PURE__*/React.createElement(Fab, {
    onClick: handleClose,
    color: "secondary",
    "aria-label": "close"
  }, /*#__PURE__*/React.createElement(CloseIcon, null)))), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      width: '100%'
    }
  }, /*#__PURE__*/React.createElement("img", {
    color: "transparent",
    iconContainerStyle: {
      border: 'none'
    },
    animationDuration: 0,
    style: {
      height: 'auto',
      width: 'auto',
      paddingTop: 0
    },
    imageStyle: {
      maxWidth: '100%',
      maxHeight: '100%',
      minHeight: '80%',
      width: 'auto',
      height: 'auto',
      padding: 0,
      position: 'relative',
      borderRadius: 5
    },
    src: src
  }))))));
};

export default ImageViewer;