import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React, { useEffect, useState } from 'react';
import Page from 'material-ui-shell/lib/containers/Page/Page';
import Scrollbar from 'material-ui-shell/lib/components/Scrollbar';
import ReactMarkdown from 'react-markdown';

var loadData = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(path) {
    var data, text;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return fetch(path);

          case 2:
            data = _context.sent;
            _context.next = 5;
            return data.text();

          case 5:
            text = _context.sent;
            return _context.abrupt("return", text);

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function loadData(_x) {
    return _ref.apply(this, arguments);
  };
}(); // eslint-disable-next-lin


var MarkdownPage = function MarkdownPage(_ref2) {
  var path = _ref2.path,
      pageProps = _ref2.pageProps;

  var _useState = useState(null),
      source = _useState[0],
      setSource = _useState[1];

  useEffect(function () {
    loadData(path).then(function (text) {
      setSource(text);
    });
  }, [path]);
  return /*#__PURE__*/React.createElement(Page, pageProps, /*#__PURE__*/React.createElement(Scrollbar, null, /*#__PURE__*/React.createElement("div", {
    style: {
      padding: 12
    }
  }, source && /*#__PURE__*/React.createElement(ReactMarkdown, {
    className: "markdown-body",
    children: source
  }))));
};

export default MarkdownPage;