import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import Delete from "@mui/icons-material/Delete";
import IconButton from "@mui/material/IconButton";
import Page from "material-ui-shell/lib/containers/Page";
import React, { useState } from "react";
import Save from "@mui/icons-material/Save";
import { useNavigate } from "react-router-dom";
import { usePaths } from "../../providers/Firebase/Paths";
import { useQuestions } from "material-ui-shell/lib/providers/Dialogs/Question";
import { useAuth } from "base-shell/lib/providers/Auth";
import FirebaseForm from "../../containers/FirebaseForm";
import { getDatabase, ref, set } from "firebase/database";
export default function FormPage(props) {
  var uid = props.uid,
      _props$path = props.path,
      path = _props$path === void 0 ? "none" : _props$path,
      _props$getPageProps = props.getPageProps,
      getPageProps = _props$getPageProps === void 0 ? function () {} : _props$getPageProps,
      _props$handleDelete = props.handleDelete,
      handleDelete = _props$handleDelete === void 0 ? function () {} : _props$handleDelete,
      _props$deleteDialogPr = props.deleteDialogProps,
      deleteDialogProps = _props$deleteDialogPr === void 0 ? {} : _props$deleteDialogPr,
      _props$grants = props.grants,
      grants = _props$grants === void 0 ? {} : _props$grants,
      _props$initialValues = props.initialValues,
      initialValues = _props$initialValues === void 0 ? {} : _props$initialValues,
      _props$useSave = props.useSave,
      useSave = _props$useSave === void 0 ? true : _props$useSave,
      _props$useDelete = props.useDelete,
      useDelete = _props$useDelete === void 0 ? true : _props$useDelete,
      _props$alwaysAllowSav = props.alwaysAllowSave,
      alwaysAllowSave = _props$alwaysAllowSav === void 0 ? false : _props$alwaysAllowSav,
      _props$alwaysAllowDel = props.alwaysAllowDelete,
      alwaysAllowDelete = _props$alwaysAllowDel === void 0 ? false : _props$alwaysAllowDel;
  var navigate = useNavigate();

  var _useQuestions = useQuestions(),
      openDialog = _useQuestions.openDialog;

  var _usePaths = usePaths(),
      getPath = _usePaths.getPath;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _useState = useState(false),
      submit = _useState[0],
      setSubmit = _useState[1];

  var db = getDatabase();

  var _ref = auth || {},
      _ref$isGranted = _ref.isGranted,
      isGranted = _ref$isGranted === void 0 ? function () {
    return false;
  } : _ref$isGranted;

  var databasePath = path + "/" + uid;
  var data = getPath(databasePath, {}) || initialValues;

  var openDeleteDialog = function openDeleteDialog() {
    openDialog(_extends({
      handleAction: function () {
        var _handleAction = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(handleClose) {
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return set(ref(db, path + "/" + uid), null);

                case 2:
                  handleClose();
                  handleDelete();

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function handleAction(_x) {
          return _handleAction.apply(this, arguments);
        }

        return handleAction;
      }()
    }, deleteDialogProps));
  };

  return /*#__PURE__*/React.createElement(Page, _extends({
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    appBarContent: /*#__PURE__*/React.createElement("div", null, useSave && /*#__PURE__*/React.createElement(IconButton, {
      disabled: !isGranted(auth, grants.create) && !alwaysAllowSave,
      color: "inherit",
      onClick: function onClick(e) {
        submit(e);
      }
    }, /*#__PURE__*/React.createElement(Save, null)), useDelete && /*#__PURE__*/React.createElement(IconButton, {
      disabled: !uid || !isGranted(auth, grants["delete"]) && !alwaysAllowDelete,
      color: "inherit",
      onClick: function onClick() {
        openDeleteDialog();
      }
    }, /*#__PURE__*/React.createElement(Delete, null)))
  }, getPageProps({
    values: data,
    submit: submit
  })), /*#__PURE__*/React.createElement(FirebaseForm, _extends({
    setSubmit: setSubmit,
    submit: submit
  }, props)));
}