function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import Add from '@mui/icons-material/Add';
import Fab from '@mui/material/Fab';
import ListPage from 'material-ui-shell/lib/containers/Page/ListPage';
import React, { useEffect } from 'react';
import { useAuth } from 'base-shell/lib/providers/Auth';
import { useLists } from '../../providers/Firebase/Lists';
import useMediaQuery from '@mui/material/useMediaQuery';

var Page = function Page(_ref) {
  var _ref$fields = _ref.fields,
      fields = _ref$fields === void 0 ? [] : _ref$fields,
      _ref$path = _ref.path,
      path = _ref$path === void 0 ? 'none' : _ref$path,
      _ref$getRef = _ref.getRef,
      getRef = _ref$getRef === void 0 ? false : _ref$getRef,
      Row = _ref.Row,
      _ref$listProps = _ref.listProps,
      listProps = _ref$listProps === void 0 ? {} : _ref$listProps,
      _ref$getPageProps = _ref.getPageProps,
      _getPageProps = _ref$getPageProps === void 0 ? function () {} : _ref$getPageProps,
      _ref$onCreateClick = _ref.onCreateClick,
      onCreateClick = _ref$onCreateClick === void 0 ? function () {} : _ref$onCreateClick,
      createGrant = _ref.createGrant,
      listPageProps = _ref.listPageProps,
      _ref$reverse = _ref.reverse,
      reverse = _ref$reverse === void 0 ? false : _ref$reverse,
      _ref$disableCreate = _ref.disableCreate,
      disableCreate = _ref$disableCreate === void 0 ? false : _ref$disableCreate,
      _ref$fabLabel = _ref.fabLabel,
      fabLabel = _ref$fabLabel === void 0 ? null : _ref$fabLabel;

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      isListLoading = _useLists.isListLoading,
      unwatchList = _useLists.unwatchList;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _ref2 = auth || {},
      _ref2$isGranted = _ref2.isGranted,
      isGranted = _ref2$isGranted === void 0 ? function () {
    return false;
  } : _ref2$isGranted;

  var matches = useMediaQuery('(min-width:400px)');
  useEffect(function () {
    var ref = path;

    if (getRef) {
      ref = getRef();
    }

    watchList(ref, path);
    return function () {
      return unwatchList(path);
    };
  }, [getRef, path, watchList, unwatchList]);
  var source = getList(path).map(function (_ref3) {
    var key = _ref3.key,
        val = _ref3.val;
    return _extends({
      key: key
    }, val);
  });
  var list = reverse ? [].concat(source).reverse() : source;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListPage, _extends({
    name: path,
    list: list,
    fields: fields,
    Row: Row,
    listProps: listProps,
    getPageProps: function getPageProps(list) {
      return _extends({
        isLoading: isListLoading(path)
      }, _getPageProps(list));
    }
  }, listPageProps)), isGranted(auth, createGrant) && !disableCreate && /*#__PURE__*/React.createElement(Fab, {
    variant: matches && fabLabel ? 'extended' : undefined,
    color: "secondary",
    style: {
      position: 'absolute',
      bottom: 18,
      right: 18
    },
    onClick: onCreateClick
  }, /*#__PURE__*/React.createElement(Add, null), " ", matches ? fabLabel : null));
};

export default Page;