import Button from '@mui/material/Button';
import IconButton from '@mui/material/IconButton';
import MenuIcon from '@mui/icons-material/Menu';
import ChevronRight from '@mui/icons-material/ChevronRight';
import Reorder from '@mui/icons-material/Reorder';
import React, { useState } from 'react';
import { Typography } from '@mui/material';
import Drawer from '@mui/material/Drawer';
import Divider from '@mui/material/Divider';
import List from '@mui/material/List';
import ListItem from '@mui/material/ListItem';
import ListItemIcon from '@mui/material/ListItemIcon';
import ListItemText from '@mui/material/ListItemText';
import { useTheme } from '@emotion/react';
import { styled } from '@mui/material/styles';
var DesktopDiv = styled('div')(function (_ref) {
  var _ref2;

  var theme = _ref.theme;
  return _ref2 = {
    display: 'none'
  }, _ref2[theme.breakpoints.up('md')] = {
    display: 'flex'
  }, _ref2;
});
var MobileDiv = styled('div')(function (_ref3) {
  var _ref4;

  var theme = _ref3.theme;
  return _ref4 = {
    display: 'flex'
  }, _ref4[theme.breakpoints.up('md')] = {
    display: 'none'
  }, _ref4;
});

var ResponsiveMenu = function ResponsiveMenu(_ref5) {
  var scroll = _ref5.scroll,
      _ref5$sections = _ref5.sections,
      sections = _ref5$sections === void 0 ? [] : _ref5$sections,
      handleMenuClose = _ref5.handleMenuClose,
      statemobileMoreAnchorEl = _ref5.statemobileMoreAnchorEl,
      transparent = _ref5.transparent,
      _ref5$contrastColor = _ref5.contrastColor,
      contrastColor = _ref5$contrastColor === void 0 ? 'white' : _ref5$contrastColor;

  var _useState = useState(false),
      isOpen = _useState[0],
      setOpen = _useState[1];

  var theme = useTheme();

  var handleOpen = function handleOpen(e) {
    setOpen(true);
  };

  var handleClose = function handleClose() {
    setOpen(false);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DesktopDiv, {
    style: {
      color: transparent ? contrastColor : undefined
    }
  }, sections.map(function (_ref6, i) {
    var onClick = _ref6.onClick,
        name = _ref6.name,
        _ref6$isDivider = _ref6.isDivider,
        isDivider = _ref6$isDivider === void 0 ? false : _ref6$isDivider;

    if (isDivider) {
      return /*#__PURE__*/React.createElement(Divider, {
        key: "divider" + i,
        orientation: "vertical",
        flexItem: true,
        style: {
          margin: 5,
          backgroundColor: transparent ? contrastColor : null
        }
      });
    }

    return /*#__PURE__*/React.createElement(Button, {
      key: "button_" + name,
      style: {
        margin: 8
      },
      onClick: onClick,
      "aria-label": name,
      color: "inherit"
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "h6"
    }, name));
  })), /*#__PURE__*/React.createElement(MobileDiv, null, /*#__PURE__*/React.createElement(IconButton, {
    "aria-label": "show more",
    "aria-haspopup": "true",
    onClick: handleOpen,
    color: "inherit"
  }, /*#__PURE__*/React.createElement(MenuIcon, {
    style: {
      color: transparent ? contrastColor : undefined
    }
  }))), /*#__PURE__*/React.createElement(Drawer, {
    anchor: "right",
    open: isOpen,
    onClose: handleClose
  }, /*#__PURE__*/React.createElement(List, null, /*#__PURE__*/React.createElement(ListItem, {
    button: true,
    key: '0',
    onClick: handleClose
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(ChevronRight, null))), /*#__PURE__*/React.createElement(Divider, null), sections.map(function (_ref7, i) {
    var _ref7$name = _ref7.name,
        name = _ref7$name === void 0 ? '' : _ref7$name,
        _onClick = _ref7.onClick,
        icon = _ref7.icon,
        _ref7$isDivider = _ref7.isDivider,
        isDivider = _ref7$isDivider === void 0 ? false : _ref7$isDivider;

    if (isDivider) {
      return /*#__PURE__*/React.createElement(Divider, {
        key: "divider_" + i
      });
    }

    return /*#__PURE__*/React.createElement(ListItem, {
      button: true,
      key: name,
      onClick: function onClick() {
        handleClose();
        setTimeout(_onClick, 1);
      }
    }, /*#__PURE__*/React.createElement(ListItemIcon, null, icon || /*#__PURE__*/React.createElement(Reorder, null)), /*#__PURE__*/React.createElement(ListItemText, {
      primary: name
    }));
  }))));
};

export default ResponsiveMenu;