import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { Checkbox, Divider, ListItem, ListItemIcon, ListItemText } from "@mui/material";
import React, { useEffect } from "react";
import VirtualList from "material-ui-shell/lib/containers/VirtualList";
import { useFilter } from "material-ui-shell/lib/providers/Filter";
import { useLists } from "../../providers/Firebase/Lists";
import { getDatabase, ref, set } from "firebase/database"; // eslint-disable-next-line import/no-anonymous-default-export

export default function (_ref) {
  var path = _ref.path;

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getFirebaseList = _useLists.getList;

  var _useFilter = useFilter(),
      getList = _useFilter.getList;

  var db = getDatabase();
  var roles = getFirebaseList("roles");
  var userRoles = getFirebaseList(path);
  var list = getList("roles", roles.map(function (r) {
    return _extends({
      key: r.key
    }, r.val);
  }), [{
    name: "name"
  }]);
  useEffect(function () {
    watchList("roles");
    watchList(path); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [path, watchList]);

  var Row = function Row(_ref2) {
    var index = _ref2.index,
        style = _ref2.style,
        data = _ref2.data;
    var key = data.key,
        _data$name = data.name,
        name = _data$name === void 0 ? "" : _data$name;
    var isSelected = false;
    userRoles.map(function (rg) {
      if (rg.key === key) {
        isSelected = true;
      }

      return rg;
    });
    return /*#__PURE__*/React.createElement("div", {
      key: name + "_" + index,
      style: style
    }, /*#__PURE__*/React.createElement(ListItem, {
      button: true,
      alignItems: "flex-start",
      onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return set(ref(db, path + "/" + key), isSelected ? null : true);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))
    }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(Checkbox, {
      edge: "start",
      checked: isSelected,
      tabIndex: -1,
      disableRipple: true
    })), /*#__PURE__*/React.createElement(ListItemText, {
      primary: name,
      secondary: name
    })), /*#__PURE__*/React.createElement(Divider, null));
  };

  return /*#__PURE__*/React.createElement(VirtualList, {
    list: list,
    name: "roles",
    listProps: {
      itemSize: 72
    },
    Row: Row
  });
}