import _regeneratorRuntime from "@babel/runtime/regenerator";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import Avatar from '@mui/material/Avatar';
import Chat from '../../containers/Chat';
import ChatIcon from '@mui/icons-material/Chat';
import Group from '@mui/icons-material/Group';
import Security from '@mui/icons-material/Security';
import Info from '@mui/icons-material/Info';
import People from '@mui/icons-material/People';
import Person from '@mui/icons-material/Person';
import Divider from '@mui/material/Divider';
import Fab from '@mui/material/Fab';
import ListItem from '@mui/material/ListItem';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import ListItemText from '@mui/material/ListItemText';
import Page from 'material-ui-shell/lib/containers/Page';
import React, { useEffect } from 'react';
import VirtualList from 'material-ui-shell/lib/containers/VirtualList';
import useMediaQuery from '@mui/material/useMediaQuery';
import { useAuth } from 'base-shell/lib/providers/Auth';
import { useNavigate, useParams } from 'react-router-dom';
import { useIntl } from 'react-intl';
import { useLists } from '../../providers/Firebase/Lists';
import { useTheme } from '@mui/material/styles';
import { useTheme as useAppTheme } from 'material-ui-shell/lib/providers/Theme';
import { useMessaging } from '../../providers/Firebase/Messaging';
import MoreHoriz from '@mui/icons-material/MoreHoriz';
import Delete from '@mui/icons-material/Delete';
import History from '@mui/icons-material/History';
import { ListItemSecondaryAction, Menu, MenuItem, IconButton, Typography } from '@mui/material';
import ListItemIcon from '@mui/material/ListItemIcon';
import moment from 'moment';
import { getDatabase, ref, set } from 'firebase/database';

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style;
  var navigate = useNavigate();
  var intl = useIntl();

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _useAppTheme = useAppTheme(),
      isRTL = _useAppTheme.isRTL;

  var _data$displayName = data.displayName,
      displayName = _data$displayName === void 0 ? '' : _data$displayName,
      _data$lastMessage = data.lastMessage,
      lastMessage = _data$lastMessage === void 0 ? '' : _data$lastMessage,
      key = data.key,
      photoURL = data.photoURL,
      _data$path = data.path,
      path = _data$path === void 0 ? '' : _data$path,
      _data$lastCreated = data.lastCreated,
      lastCreated = _data$lastCreated === void 0 ? '' : _data$lastCreated;

  var _React$useState = React.useState(null),
      anchorEl = _React$useState[0],
      setAnchorEl = _React$useState[1];

  var _useParams = useParams(),
      _useParams$uid = _useParams.uid,
      uid = _useParams$uid === void 0 ? '' : _useParams$uid;

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  var handleDeleteChat = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return set(ref(getDatabase(), "user_chats/" + auth.uid + "/" + key), null);

            case 2:
              handleClose();

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleDeleteChat() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleMarkAsUnread = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return set(ref(getDatabase(), "user_chats/" + auth.uid + "/" + key + "/unread"), 1);

            case 2:
              handleClose();

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleMarkAsUnread() {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement("div", {
    key: key,
    style: _extends({}, style, {
      direction: isRTL ? 'rtl' : 'ltr'
    })
  }, /*#__PURE__*/React.createElement(ListItem, {
    button: true,
    selected: key === uid,
    alignItems: "flex-start",
    style: {
      height: 72
    },
    onClick: function onClick() {
      navigate("/chats/" + key);
    }
  }, /*#__PURE__*/React.createElement(ListItemAvatar, null, /*#__PURE__*/React.createElement(Avatar, {
    src: photoURL
  }, path !== '' && /*#__PURE__*/React.createElement(Group, null), path === '' && /*#__PURE__*/React.createElement(Person, null))), /*#__PURE__*/React.createElement(ListItemText, {
    primary: displayName,
    secondary: /*#__PURE__*/React.createElement("div", {
      style: {
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        maxWidth: 170,
        whiteSpace: 'nowrap'
      }
    }, lastMessage)
  }), /*#__PURE__*/React.createElement(ListItemSecondaryAction, null, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column'
    }
  }, /*#__PURE__*/React.createElement(IconButton, {
    size: "small",
    "aria-controls": "simple-menu",
    "aria-haspopup": "true",
    onClick: handleClick
  }, /*#__PURE__*/React.createElement(MoreHoriz, null)), /*#__PURE__*/React.createElement(Menu, {
    id: "simple-menu",
    anchorEl: anchorEl,
    keepMounted: true,
    open: Boolean(anchorEl),
    onClose: handleClose
  }, path !== '' && /*#__PURE__*/React.createElement(MenuItem, {
    onClick: function onClick() {
      navigate("/group_chat/" + key);
    }
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(Info, null)), intl.formatMessage({
    id: 'info',
    defaultMessage: 'Info'
  })), path !== '' && /*#__PURE__*/React.createElement(MenuItem, {
    onClick: function onClick() {
      navigate("/edit_members/" + key);
    }
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(People, null)), intl.formatMessage({
    id: 'members',
    defaultMessage: 'Members'
  })), path !== '' && /*#__PURE__*/React.createElement(MenuItem, {
    onClick: function onClick() {
      navigate("/edit_admins/" + key);
    }
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(Security, null)), intl.formatMessage({
    id: 'admins',
    defaultMessage: 'Admins'
  })), /*#__PURE__*/React.createElement(MenuItem, {
    onClick: handleDeleteChat
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(Delete, null)), path === '' && intl.formatMessage({
    id: 'delete_chat',
    defaultMessage: 'Delete chat'
  }), path !== '' && intl.formatMessage({
    id: 'delete_group_chat',
    defaultMessage: 'Delete group chat'
  })), /*#__PURE__*/React.createElement(MenuItem, {
    onClick: handleMarkAsUnread
  }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(History, null)), intl.formatMessage({
    id: 'martk_as_unread',
    defaultMessage: 'Mark as unread'
  }))), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, moment(lastCreated || moment()).format('HH:mm')), /*#__PURE__*/React.createElement("div", {
    style: {
      height: 5
    }
  })))), /*#__PURE__*/React.createElement(Divider, {
    variant: "inset"
  }));
};

export default function () {
  var intl = useIntl();
  var navigate = useNavigate();

  var _useParams2 = useParams(),
      _useParams2$uid = _useParams2.uid,
      uid = _useParams2$uid === void 0 ? '' : _useParams2$uid;

  var _useAuth2 = useAuth(),
      auth = _useAuth2.auth;

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      unwatchList = _useLists.unwatchList;

  var _useMessaging = useMessaging(),
      requestPermission = _useMessaging.requestPermission;

  var theme = useTheme();
  var matches = useMediaQuery(theme.breakpoints.up('sm'));
  var chatsPath = "user_chats/" + auth.uid;
  useEffect(function () {
    watchList(chatsPath);
    requestPermission();
    return function () {
      return unwatchList(chatsPath);
    };
  }, [chatsPath, unwatchList, watchList, requestPermission]);
  var chats = getList(chatsPath).map(function (c) {
    return _extends({
      key: c.key
    }, c.val);
  });
  var showChats = matches || !uid;
  var showMessages = matches || uid;
  var currentChat = chats.find(function (c) {
    return c.key === uid;
  });
  var path = (currentChat === null || currentChat === void 0 ? void 0 : currentChat.path) || (uid ? "user_chat_messages/" + auth.uid + "/" + uid : false);
  var title = intl.formatMessage({
    id: 'chats',
    defaultMessage: 'Chats'
  });

  if (currentChat) {
    title = currentChat === null || currentChat === void 0 ? void 0 : currentChat.displayName;
    /*
    title = (
      <div>
        <Avatar>
          <Avatar src={currentChat?.photoURL}>
            {currentChat?.path !== '' && <Group />}
            {currentChat?.path === '' && <Person />}
          </Avatar>
        </Avatar>
        <Typography>{currentChat?.displayName}</Typography>
      </div>
    )
    */
  }

  return /*#__PURE__*/React.createElement(Page, {
    onBackClick: !matches && uid ? function () {
      navigate('/chats', {
        replace: true
      });
    } : undefined,
    pageTitle: title
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      display: 'flex'
    }
  }, showChats && /*#__PURE__*/React.createElement("div", {
    style: {
      width: matches ? 300 : '100%',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement(VirtualList, {
    list: chats,
    name: 'user_chats',
    listProps: {
      itemSize: 72
    },
    Row: Row
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      bottom: 15,
      right: 15
    }
  }, /*#__PURE__*/React.createElement(Fab, {
    color: "secondary",
    onClick: function onClick() {
      navigate('/create_chat');
    }
  }, /*#__PURE__*/React.createElement(ChatIcon, null)))), showMessages && /*#__PURE__*/React.createElement("div", {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(Chat, {
    path: path
  }))));
}