import _regeneratorRuntime from "@babel/runtime/regenerator";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React, { useEffect, useState, useMemo } from "react";
import { useLists } from "../../providers/Firebase/Lists";
import ListPage from "material-ui-shell/lib/containers/Page/ListPage";
import { useIntl } from "react-intl";
import GroupAdd from "@mui/icons-material/GroupAdd";
import { useNavigate } from "react-router-dom";
import { useAuth } from "base-shell/lib/providers/Auth";
import UserRow from "../../components/UserRow";
import { getDatabase, ref, update } from "firebase/database";
import { useFilter } from "material-ui-shell/lib/providers/Filter";
import { collection, getFirestore, getDocs, query, where } from "firebase/firestore";
export default function () {
  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      isListLoading = _useLists.isListLoading;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var intl = useIntl();
  var navigate = useNavigate();

  var _useState = useState([]),
      list = _useState[0],
      setList = _useState[1];

  var _useFilter = useFilter(),
      getFilter = _useFilter.getFilter;

  var _getFilter = getFilter("users"),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var searchValue = search.value;
  var runSearch = useMemo(function () {
    return /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var db, ref, q, snap, tempLlist;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              db = getFirestore();
              ref = collection(db, "users");
              q = query(ref, where("search", "array-contains", searchValue.toLowerCase() || ""));
              _context.next = 5;
              return getDocs(q);

            case 5:
              snap = _context.sent;
              tempLlist = [];
              tempLlist.push({
                key: "new_group",
                displayName: intl.formatMessage({
                  id: "group_chat",
                  defaultMessage: "Group chat"
                }),
                secondaryText: intl.formatMessage({
                  id: "create_group_chat",
                  defaultMessage: "Create new group chat"
                }),
                search: searchValue,
                icon: /*#__PURE__*/React.createElement(GroupAdd, null),
                isGroup: true
              });
              snap.forEach(function (doc) {
                tempLlist.push(_extends({
                  key: doc.id
                }, doc.data()));
              });
              setList(tempLlist);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
  }, [searchValue, intl]);
  useEffect(function () {
    if (searchValue && searchValue !== "") {
      runSearch();
    } else {
      setList([{
        key: "new_group",
        displayName: intl.formatMessage({
          id: "group_chat",
          defaultMessage: "Group chat"
        }),
        secondaryText: intl.formatMessage({
          id: "create_group_chat",
          defaultMessage: "Create new group chat"
        }),
        icon: /*#__PURE__*/React.createElement(GroupAdd, null),
        isGroup: true
      }]);
    }
  }, [searchValue, runSearch, intl, isListLoading]);
  useEffect(function () {
    watchList("admins");
  }, [watchList]);
  var admins = getList("admins");

  var handleRowClick = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(user) {
      var key, displayName, _user$photoURL, photoURL, isGroup, userChatsRef, chatData;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              key = user.key, displayName = user.displayName, _user$photoURL = user.photoURL, photoURL = _user$photoURL === void 0 ? "" : _user$photoURL, isGroup = user.isGroup;

              if (!isGroup) {
                _context2.next = 4;
                break;
              }

              navigate("/group_chat");
              return _context2.abrupt("return");

            case 4:
              userChatsRef = ref(getDatabase(), "/user_chats/" + auth.uid + "/" + key);
              chatData = {
                displayName: displayName,
                photoURL: photoURL,
                lastMessage: ""
              };
              _context2.next = 8;
              return update(userChatsRef, _extends({}, chatData));

            case 8:
              navigate("/chats/" + key);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleRowClick(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(ListPage, {
    name: "users",
    list: list,
    Row: function Row(p) {
      return /*#__PURE__*/React.createElement(UserRow, _extends({
        admins: admins,
        handleRowClick: handleRowClick
      }, p));
    },
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: "chat_with",
          defaultMessage: "Chat with"
        }),
        isLoading: isListLoading("users"),
        onBackClick: function onBackClick() {
          navigate(-1);
        }
      };
    }
  });
}