import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect } from 'react';
import { useLists } from '../../providers/Firebase/Lists';
import ListPage from 'material-ui-shell/lib/containers/Page/ListPage';
import { useIntl } from 'react-intl';
import { useNavigate, useParams } from 'react-router-dom';
import { useAuth } from 'base-shell/lib/providers/Auth';
import UserRow from '../../components/UserRow';
import { getDatabase, ref, set } from 'firebase/database';
export default function () {
  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      clearList = _useLists.clearList,
      isListLoading = _useLists.isListLoading;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var intl = useIntl();
  var navigate = useNavigate();

  var _useParams = useParams(),
      uid = _useParams.uid;

  var groupAdminsPath = "group_chats/" + uid + "/admins";
  var db = getDatabase();
  useEffect(function () {
    watchList('users');
    watchList('admins');
    watchList(groupAdminsPath);
    return function () {
      clearList(groupAdminsPath);
    };
  }, [watchList, clearList, groupAdminsPath]);
  var admins = getList('admins');
  var members = getList(groupAdminsPath);
  var list = getList('users').map(function (_ref) {
    var key = _ref.key,
        val = _ref.val;
    return _extends({
      key: key
    }, val);
  }).filter(function (u) {
    return u.key !== auth.uid;
  });

  var isChecked = function isChecked(key) {
    return members.find(function (m) {
      return m.key === key;
    });
  };

  var handleRowClick = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(user) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return set(ref(db, groupAdminsPath).child(user.key), isChecked(user.key) ? null : true);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleRowClick(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListPage, {
    name: "users",
    list: list,
    Row: function Row(p) {
      return /*#__PURE__*/React.createElement(UserRow, _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick,
        hasCheckbox: true,
        isChecked: isChecked(p.data.key)
      }));
    },
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: 'edit_admins',
          defaultMessage: 'Edit admins'
        }),
        isLoading: isListLoading('users'),
        onBackClick: function onBackClick() {
          navigate(-1);
        }
      };
    }
  }));
}