import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect, useState } from 'react';
import { useLists } from '../../providers/Firebase/Lists';
import { usePaths } from '../../providers/Firebase/Paths';
import ListPage from 'material-ui-shell/lib/containers/Page/ListPage';
import { useIntl } from 'react-intl';
import Fab from '@mui/material/Fab';
import ArrowForward from '@mui/icons-material/ArrowForward';
import { useNavigate, useParams } from 'react-router-dom';
import { useAuth } from 'base-shell/lib/providers/Auth';
import TextField from '@mui/material/TextField';
import { Paper } from '@mui/material';
import Page from 'material-ui-shell/lib/containers/Page';
import UserRow from '../../components/UserRow';
import { getDatabase, ref, update, push, set } from 'firebase/database';
export default function () {
  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      isListLoading = _useLists.isListLoading;

  var _usePaths = usePaths(),
      watchPath = _usePaths.watchPath,
      getPath = _usePaths.getPath,
      clearPath = _usePaths.clearPath;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var intl = useIntl();
  var navigate = useNavigate();

  var _useParams = useParams(),
      _useParams$uid = _useParams.uid,
      uid = _useParams$uid === void 0 ? false : _useParams$uid;

  var _useState = useState({}),
      selected = _useState[0],
      setSelected = _useState[1];

  var _useState2 = useState(uid !== false ? 1 : 0),
      step = _useState2[0],
      setStep = _useState2[1];

  var db = getDatabase();

  var _ref = getPath("group_chats/" + uid, {}) || {},
      _ref$name = _ref.name,
      currentName = _ref$name === void 0 ? '' : _ref$name;

  var _useState3 = useState(''),
      name = _useState3[0],
      setName = _useState3[1];

  useEffect(function () {
    watchList('users');
    watchList('admins');

    if (uid) {
      watchPath("group_chats/" + uid);
    }

    return function () {
      if (uid) {
        clearPath("group_chats/" + uid);
      }
    };
  }, [watchList, uid, watchPath, clearPath]);
  useEffect(function () {
    setName(currentName);
  }, [currentName]);
  var admins = getList('admins');
  var list = getList('users').map(function (_ref2) {
    var key = _ref2.key,
        val = _ref2.val;
    return _extends({
      key: key
    }, val);
  }).filter(function (u) {
    return u.key !== auth.uid;
  });

  var handleRowClick = function handleRowClick(user) {
    var key = user.key;

    if (!selected[key]) {
      var _extends2;

      setSelected(_extends({}, selected, (_extends2 = {}, _extends2[key] = user, _extends2)));
    } else {
      var removed = selected[key],
          rest = _objectWithoutPropertiesLoose(selected, [key].map(_toPropertyKey));

      setSelected(rest);
    }
  };

  var handleNextClick = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _members, members, snap;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(step === 0)) {
                _context.next = 4;
                break;
              }

              setStep(1);
              _context.next = 20;
              break;

            case 4:
              if (!uid) {
                _context.next = 10;
                break;
              }

              _context.next = 7;
              return update(ref(db, "group_chats/" + uid), {
                name: name
              });

            case 7:
              navigate('/chats');
              _context.next = 20;
              break;

            case 10:
              members = (_members = {}, _members[auth.uid] = true, _members);
              Object.entries(selected).map(function (e) {
                var key = e[0];
                members[key] = true;
                return e;
              });
              _context.next = 14;
              return push(ref(db, "group_chats"));

            case 14:
              snap = _context.sent;
              _context.next = 17;
              return set(ref(db, "group_chats/" + snap.key + "/admins/" + auth.uid), true);

            case 17:
              _context.next = 19;
              return update(ref(db, "group_chats/" + snap.key), {
                members: members,
                name: name
              });

            case 19:
              navigate('/chats');

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleNextClick() {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(React.Fragment, null, step === 0 && /*#__PURE__*/React.createElement(ListPage, {
    name: "users",
    list: list,
    Row: function Row(p) {
      return /*#__PURE__*/React.createElement(UserRow, _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick,
        hasCheckbox: true,
        isChecked: selected[p.data.key]
      }));
    },
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: 'select_users',
          defaultMessage: 'Select Users'
        }),
        isLoading: isListLoading('users'),
        onBackClick: function onBackClick() {
          navigate(-1);
        }
      };
    }
  }), step === 1 && /*#__PURE__*/React.createElement(Page, {
    pageTitle: intl.formatMessage({
      id: 'set_name',
      defaultMessage: 'Set name'
    })
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      width: '100%',
      height: '100%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  }, /*#__PURE__*/React.createElement(Paper, {
    style: {
      padding: 18
    }
  }, /*#__PURE__*/React.createElement(TextField, {
    name: "name",
    placeholder: intl.formatMessage({
      id: 'group_name',
      defaultMessage: 'Group name'
    }),
    value: name,
    onChange: function onChange(e) {
      return setName(e.target.value);
    }
  })))), /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      bottom: 15,
      right: 35
    }
  }, /*#__PURE__*/React.createElement(Fab, {
    disabled: step === 1 && name === '',
    color: "secondary",
    onClick: handleNextClick
  }, /*#__PURE__*/React.createElement(ArrowForward, null))));
}