import _regeneratorRuntime from "@babel/runtime/regenerator";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React from 'react';
import { useIntl } from 'react-intl';
import Page from 'material-ui-shell/lib/containers/Page/Page';
import { useParams, useNavigate } from 'react-router-dom';
import Tab from '@mui/material/Tab';
import Tabs from '@mui/material/Tabs';
import Divider from '@mui/material/Divider';
import AccountBox from '@mui/icons-material/AccountBox';
import Save from '@mui/icons-material/Save';
import Delete from '@mui/icons-material/Delete';
import Lock from '@mui/icons-material/Lock';
import GrantsList from '../../containers/GrantsList';
import Zoom from '@mui/material/Zoom';
import SearchField from 'material-ui-shell/lib/components/SearchField';
import { useFilter } from 'material-ui-shell/lib/providers/Filter';
import FirebaseFrom from '../../containers/FirebaseForm';
import Form from '../../components/Forms/Role';
import IconButton from '@mui/material/IconButton';
import { useAuth } from 'base-shell/lib/providers/Auth';
import { useQuestions } from 'material-ui-shell/lib/providers/Dialogs/Question';
import { getDatabase, ref, set } from 'firebase/database';
import Box from '@mui/material/Box';
var path = 'roles';
var singular = 'role';
export default function () {
  var intl = useIntl();
  var navigate = useNavigate();

  var _useParams = useParams(),
      uid = _useParams.uid,
      _useParams$tab = _useParams.tab,
      tab = _useParams$tab === void 0 ? 'main' : _useParams$tab;

  var _useFilter = useFilter(),
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch;

  var _getFilter = getFilter(tab),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var _useQuestions = useQuestions(),
      openDialog = _useQuestions.openDialog;

  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _auth$isGranted = auth.isGranted,
      isGranted = _auth$isGranted === void 0 ? function () {
    return false;
  } : _auth$isGranted;
  var _search$value = search.value,
      searchValue = _search$value === void 0 ? '' : _search$value;
  var submit;

  var setSubmit = function setSubmit(s) {
    submit = s;
  };

  var grantsPath = "role_grants/" + uid;

  var openDeleteDialog = function openDeleteDialog() {
    openDialog({
      handleAction: function () {
        var _handleAction = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(handleClose) {
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return set(ref(getDatabase(), path + "/" + uid), null);

                case 2:
                  handleClose();
                  navigate("/" + path);

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function handleAction(_x) {
          return _handleAction.apply(this, arguments);
        }

        return handleAction;
      }(),
      title: intl.formatMessage({
        id: "delete_" + singular + "_dialog_title",
        defaultMessage: 'Delete Role?'
      }),
      message: intl.formatMessage({
        id: "delete_" + singular + "_dialog_message",
        defaultMessage: 'Role will be deleted permanently?'
      }),
      action: intl.formatMessage({
        id: "delete_" + singular + "_dialog_action",
        defaultMessage: 'DELETE ROLE'
      })
    });
  };

  return /*#__PURE__*/React.createElement(Page, {
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    pageTitle: intl.formatMessage({
      id: 'role',
      defaultMessage: 'Role'
    }),
    appBarContent: /*#__PURE__*/React.createElement("div", null, tab === 'main' && /*#__PURE__*/React.createElement(Zoom, {
      key: tab,
      "in": tab === 'main'
    }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(IconButton, {
      disabled: !uid && !isGranted(auth, "create_" + singular) || !isGranted(auth, "edit_" + singular),
      color: "inherit",
      onClick: function onClick(e) {
        return submit(e);
      }
    }, /*#__PURE__*/React.createElement(Save, null)), /*#__PURE__*/React.createElement(IconButton, {
      disabled: !uid || !isGranted(auth, "delete_" + singular),
      color: "inherit",
      onClick: function onClick() {
        openDeleteDialog();
      }
    }, /*#__PURE__*/React.createElement(Delete, null)))), tab !== 'main' && /*#__PURE__*/React.createElement(Zoom, {
      key: tab,
      "in": tab !== 'main'
    }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(SearchField, {
      initialValue: searchValue,
      onChange: function onChange(v) {
        setSearch(tab, v);
      }
    })))),
    tabs: /*#__PURE__*/React.createElement(Box, null, /*#__PURE__*/React.createElement(Tabs, {
      value: tab,
      onChange: function onChange(e, t) {
        navigate("/roles/" + uid + "/" + t, {
          replace: true
        });
      },
      centered: true
    }, /*#__PURE__*/React.createElement(Tab, {
      value: "main",
      icon: /*#__PURE__*/React.createElement(AccountBox, {
        color: "inherit"
      })
    }), /*#__PURE__*/React.createElement(Tab, {
      value: "grants",
      icon: /*#__PURE__*/React.createElement(Lock, null)
    })), /*#__PURE__*/React.createElement(Divider, null))
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%'
    }
  }, tab === 'main' && /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement(FirebaseFrom, {
    path: "" + path,
    uid: uid,
    setSubmit: setSubmit,
    handleSubmit: function handleSubmit(values, newUid) {
      if (newUid) {
        navigate("/" + path + "/" + newUid, {
          replace: true
        });
      } else {
        navigate("/" + path);
      }
    },
    Form: Form
  })), tab === 'grants' && /*#__PURE__*/React.createElement(GrantsList, {
    grantsPath: grantsPath
  }))));
}