import AccountBoxIcon from '@mui/icons-material/AccountBox';
import Avatar from '@mui/material/Avatar';
import Divider from '@mui/material/Divider';
import ListItem from '@mui/material/ListItem';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import ListItemText from '@mui/material/ListItemText';
import React from 'react';
import { ListPage } from '../../containers/Page';
import { useNavigate } from 'react-router-dom';
import { useIntl } from 'react-intl';
var fields = [{
  name: 'name',
  label: 'Name'
}, {
  name: 'description',
  label: 'Description'
}];

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style;
  var _data$name = data.name,
      name = _data$name === void 0 ? '' : _data$name,
      _data$description = data.description,
      description = _data$description === void 0 ? '' : _data$description,
      key = data.key;
  var navigate = useNavigate();
  return /*#__PURE__*/React.createElement("div", {
    key: key,
    style: style
  }, /*#__PURE__*/React.createElement(ListItem, {
    button: true,
    alignItems: "flex-start",
    style: {
      height: 72
    },
    onClick: function onClick() {
      navigate("/roles/" + key + "/main");
    }
  }, /*#__PURE__*/React.createElement(ListItemAvatar, null, /*#__PURE__*/React.createElement(Avatar, null, /*#__PURE__*/React.createElement(AccountBoxIcon, null))), /*#__PURE__*/React.createElement(ListItemText, {
    primary: name,
    secondary: description
  })), /*#__PURE__*/React.createElement(Divider, {
    variant: "inset"
  }));
};

export default function () {
  var intl = useIntl();
  var navigate = useNavigate();
  return /*#__PURE__*/React.createElement(ListPage, {
    fields: fields,
    path: "roles",
    createGrant: "create_role",
    Row: Row,
    listProps: {
      itemSize: 72
    },
    getPageProps: function getPageProps() {
      return {
        pageTitle: intl.formatMessage({
          id: 'roles',
          defaultMessage: 'Roles'
        })
      };
    },
    onCreateClick: function onCreateClick() {
      navigate('/create_role');
    }
  });
}