function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import * as firebaseui from "firebaseui";
import AuthUI from "../../containers/AuthUI/AuthUI";
import Page from "material-ui-shell/lib/containers/Page/Page";
import React from "react";
import { Helmet } from "react-helmet";
import { useConfig } from "base-shell/lib/providers/Config";
import { useIntl } from "react-intl";
import { useMenu } from "material-ui-shell/lib/providers/Menu";
import { useNavigate, useLocation } from "react-router-dom";

var SignIn = function SignIn() {
  var intl = useIntl();

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var _ref = appConfig || {},
      _ref$firebase = _ref.firebase,
      firebase = _ref$firebase === void 0 ? {} : _ref$firebase,
      auth = _ref.auth;

  var _ref2 = auth || {},
      _ref2$redirectTo = _ref2.redirectTo,
      redirectTo = _ref2$redirectTo === void 0 ? "/" : _ref2$redirectTo;

  var _firebase$firebaseuiP = firebase.firebaseuiProps,
      firebaseuiProps = _firebase$firebaseuiP === void 0 ? {} : _firebase$firebaseuiP;

  var _useMenu = useMenu(),
      toggleThis = _useMenu.toggleThis;

  var navigate = useNavigate();
  var location = useLocation();
  var from = new URLSearchParams(location.search).get("from") || redirectTo;

  var uiConfig = _extends({
    signInSuccessUrl: from,
    signInFlow: "popup",
    callbacks: {
      signInSuccessWithAuthResult: function signInSuccessWithAuthResult() {
        toggleThis("isAuthMenuOpen", false); // To avoid page reload on single page applications

        return false;
      }
    },
    credentialHelper: firebaseui.auth.CredentialHelper.NONE
  }, firebaseuiProps);

  return /*#__PURE__*/React.createElement(Page, {
    pageTitle: intl.formatMessage({
      id: "sign_in"
    })
  }, /*#__PURE__*/React.createElement(Helmet, null, /*#__PURE__*/React.createElement("link", {
    type: "text/css",
    rel: "stylesheet",
    href: "https://www.gstatic.com/firebasejs/ui/4.6.1/firebase-ui-auth.css"
  })), /*#__PURE__*/React.createElement(AuthUI, {
    uiConfig: uiConfig
  }));
};

export default SignIn;