import Avatar from '@mui/material/Avatar';
import Paper from '@mui/material/Paper';
import React, { useEffect } from 'react';
import Typography from '@mui/material/Typography';
import { Divider, IconButton } from '@mui/material';
import { useIntl } from 'react-intl';
import { GoogleIcon, FacebookIcon, GitHubIcon, TwitterIcon } from '../../components/Icons';
import Page from 'material-ui-shell/lib/containers/Page/Page';
import { usePaths } from '../../providers/Firebase/Paths';
import { useLists } from '../../providers/Firebase/Lists';
import { useParams, useNavigate } from 'react-router-dom';
import Box from '@mui/material/Box';
import Tab from '@mui/material/Tab';
import Tabs from '@mui/material/Tabs';
import AccountBox from '@mui/icons-material/AccountBox';
import Lock from '@mui/icons-material/Lock';
import Person from '@mui/icons-material/Person';
import Email from '@mui/icons-material/Email';
import GrantsList from '../../containers/GrantsList';
import RolesList from '../../containers/RolesList';
import Zoom from '@mui/material/Zoom';
import SearchField from 'material-ui-shell/lib/components/SearchField';
import { useFilter } from 'material-ui-shell/lib/providers/Filter';
import FormControlLabel from '@mui/material/FormControlLabel';
import Switch from '@mui/material/Switch';
import { getDatabase, ref, set } from 'firebase/database';
export default function () {
  var intl = useIntl();
  var navigate = useNavigate();

  var _usePaths = usePaths(),
      watchPath = _usePaths.watchPath,
      getPath = _usePaths.getPath;

  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList;

  var _useParams = useParams(),
      uid = _useParams.uid,
      _useParams$tab = _useParams.tab,
      tab = _useParams$tab === void 0 ? 'main' : _useParams$tab;

  var _useFilter = useFilter(),
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch;

  var _getFilter = getFilter(tab),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var _search$value = search.value,
      searchValue = _search$value === void 0 ? '' : _search$value;
  var grantsPath = "user_grants/" + uid;
  var rolesPath = "user_roles/" + uid;

  var getProviderIcon = function getProviderIcon(id) {
    if (id === 'password') {
      return /*#__PURE__*/React.createElement(Email, null);
    }

    if (id === 'google.com') {
      return /*#__PURE__*/React.createElement(GoogleIcon, null);
    }

    if (id === 'facebook.com') {
      return /*#__PURE__*/React.createElement(FacebookIcon, null);
    }

    if (id === 'github.com') {
      return /*#__PURE__*/React.createElement(GitHubIcon, null);
    }

    if (id === 'twitter.com') {
      return /*#__PURE__*/React.createElement(TwitterIcon, null);
    }

    return null;
  };

  var path = "users/" + uid;
  useEffect(function () {
    watchPath(path);
    watchList('admins'); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [path]);
  var user = getPath(path, {});
  var admins = getList('admins');

  var _ref = user || {},
      _ref$photoURL = _ref.photoURL,
      photoURL = _ref$photoURL === void 0 ? '' : _ref$photoURL,
      _ref$displayName = _ref.displayName,
      displayName = _ref$displayName === void 0 ? '' : _ref$displayName,
      _ref$email = _ref.email,
      email = _ref$email === void 0 ? '' : _ref$email,
      _ref$providerData = _ref.providerData,
      providerData = _ref$providerData === void 0 ? [] : _ref$providerData;

  var isAdmin = false;
  admins.map(function (a) {
    if (a.key === uid) {
      isAdmin = true;
    }

    return a;
  });
  return /*#__PURE__*/React.createElement(Page, {
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    pageTitle: intl.formatMessage({
      id: 'user',
      defaultMessage: 'User'
    }),
    appBarContent: /*#__PURE__*/React.createElement("div", null, tab !== 'main' && /*#__PURE__*/React.createElement(Zoom, {
      key: tab,
      "in": tab !== 'main'
    }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(SearchField, {
      initialValue: searchValue,
      onChange: function onChange(v) {
        setSearch(tab, v);
      }
    })))),
    tabs: /*#__PURE__*/React.createElement(Box, null, /*#__PURE__*/React.createElement(Tabs, {
      value: tab,
      onChange: function onChange(e, t) {
        navigate("/users/" + uid + "/" + t, {
          replace: true
        });
      },
      centered: true
    }, /*#__PURE__*/React.createElement(Tab, {
      value: "main",
      icon: /*#__PURE__*/React.createElement(Person, {
        className: "material-icons"
      })
    }), /*#__PURE__*/React.createElement(Tab, {
      value: "roles",
      icon: /*#__PURE__*/React.createElement(AccountBox, {
        className: "material-icons"
      })
    }), /*#__PURE__*/React.createElement(Tab, {
      value: "grants",
      icon: /*#__PURE__*/React.createElement(Lock, {
        className: "material-icons"
      })
    })), /*#__PURE__*/React.createElement(Divider, null))
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%'
    }
  }, tab === 'main' && /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement(Paper, {
    elevation: 3,
    style: {
      position: 'relative',
      //width: 300,
      //height: 300,
      borderRadius: 18,
      display: 'flex',
      justifyContent: 'flex-start',
      flexDirection: 'column',
      alignItems: 'center',
      padding: 18,
      minWidth: 250
    }
  }, /*#__PURE__*/React.createElement(Avatar, {
    style: {
      width: 120,
      height: 120,
      marginTop: -70
    },
    alt: "User Picture",
    src: photoURL
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      flexDirection: 'column',
      marginTop: 18,
      marginBottom: 18
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "h4"
  }, displayName), /*#__PURE__*/React.createElement(Typography, {
    variant: "h6"
  }, email), /*#__PURE__*/React.createElement("div", {
    style: {
      margin: 18,
      display: 'flex',
      alignItems: 'center'
    }
  }, providerData.map(function (so) {
    return getProviderIcon(so.providerId) ? /*#__PURE__*/React.createElement(IconButton, {
      color: "primary",
      key: so
    }, getProviderIcon(so.providerId)) : null;
  })), /*#__PURE__*/React.createElement(FormControlLabel, {
    control: /*#__PURE__*/React.createElement(Switch, {
      checked: isAdmin,
      onChange: function onChange() {
        try {
          set(ref(getDatabase(), "admins/" + uid), isAdmin ? null : true);
        } catch (error) {
          console.warn(error);
        }
      },
      name: "checkedA"
    }),
    label: intl.formatMessage({
      id: 'administrator',
      defaultMessage: 'Administrator'
    })
  })))), tab === 'roles' && /*#__PURE__*/React.createElement(RolesList, {
    path: rolesPath
  }), tab === 'grants' && /*#__PURE__*/React.createElement(GrantsList, {
    grantsPath: grantsPath
  }))));
}