import _regeneratorRuntime from "@babel/runtime/regenerator";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React, { useEffect, useMemo, useState } from "react";
import { useLists } from "../../providers/Firebase/Lists";
import ListPage from "material-ui-shell/lib/containers/Page/ListPage";
import { useIntl } from "react-intl";
import { useNavigate } from "react-router-dom";
import UserRow from "../../components/UserRow";
import { useFilter } from "material-ui-shell/lib/providers/Filter";
import { collection, getFirestore, getDocs, query, where } from "firebase/firestore";
var fields = [{
  name: "displayName",
  label: "Name"
}];
export default function () {
  var _useLists = useLists(),
      watchList = _useLists.watchList,
      getList = _useLists.getList;

  var intl = useIntl();
  var navigate = useNavigate();

  var _useState = useState([]),
      list = _useState[0],
      setList = _useState[1];

  var _useState2 = useState(false),
      isLoading = _useState2[0],
      setLoading = _useState2[1];

  var _useFilter = useFilter(),
      getFilter = _useFilter.getFilter;

  var _getFilter = getFilter("users"),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var searchValue = search.value;
  var runSearch = useMemo(function () {
    return /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var db, ref, q, snap, tempLlist;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);
              db = getFirestore();
              ref = collection(db, "users");
              q = query(ref, where("search", "array-contains", searchValue.toLowerCase() || ""));
              _context.next = 6;
              return getDocs(q);

            case 6:
              snap = _context.sent;
              tempLlist = [];
              snap.forEach(function (doc) {
                tempLlist.push(_extends({
                  key: doc.id
                }, doc.data()));
              });
              setList(tempLlist);
              setLoading(false);

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
  }, [searchValue]);
  useEffect(function () {
    if (searchValue && searchValue !== "") {
      runSearch();
    } else {
      setList([]);
    }
  }, [runSearch, searchValue]);
  useEffect(function () {
    watchList("admins");
  }, [watchList]);
  var admins = getList("admins");

  var handleRowClick = function handleRowClick(data) {
    console.log("data", data);
    navigate("/users/" + data.key);
  };

  return /*#__PURE__*/React.createElement(ListPage, {
    name: "users",
    list: list,
    fields: fields,
    Row: function Row(p) {
      return /*#__PURE__*/React.createElement(UserRow, _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick
      }));
    },
    disableFilter: true,
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: "users_page",
          defaultMessage: "Users {count}"
        }, {
          count: list.length
        }),
        isLoading: isLoading
      };
    }
  });
}