var getUsersPreferredLanguages = function getUsersPreferredLanguages() {
  if (navigator.languages !== undefined) {
    return navigator.languages;
  } else if (navigator.language !== undefined) {
    return [navigator.language];
  } else {
    return undefined;
  }
};

var parseLanguages = function parseLanguages(acceptedLangs, defaultLang) {
  if (defaultLang === void 0) {
    defaultLang = false;
  }

  var userPref = getUsersPreferredLanguages();
  var match = userPref ? userPref.find(function (lang) {
    return acceptedLangs.includes(lang);
  }) : undefined;

  if (match === undefined && defaultLang !== false) {
    return defaultLang;
  }

  return match;
};

var formatMessage = function formatMessage(messages, id) {
  if (messages === void 0) {
    messages = [];
  }

  return messages[id] || id;
};

export { formatMessage };
export default parseLanguages;