"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _iconsMaterial = require("@mui/icons-material");

var _material = require("@mui/material");

var _styles = require("@mui/material/styles");

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _Auth = require("base-shell/lib/providers/Auth");

var _Config = require("base-shell/lib/providers/Config");

var _reactRouterDom = require("react-router-dom");

var _reactIntl = require("react-intl");

var _ImageViewer = _interopRequireDefault(require("../../containers/ImageViewer"));

var _reactLinkify = _interopRequireDefault(require("react-linkify"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getMapLoc = function getMapLoc(loc) {
  var lat = 0;
  var lng = 0;

  if (loc) {
    var data = loc.split('@') ? loc.split('@')[1] : false;

    if (data) {
      lat = data.split(',')[0];
      lng = data.split(',')[1];
    }
  }

  return {
    lat: lat,
    lng: lng
  };
};

function _default(_ref) {
  var data = _ref.message,
      path = _ref.path,
      uid = _ref.uid,
      _ref$userChanged = _ref.userChanged,
      userChanged = _ref$userChanged === void 0 ? false : _ref$userChanged,
      _ref$dateChanged = _ref.dateChanged,
      dateChanged = _ref$dateChanged === void 0 ? false : _ref$dateChanged;
  var navigate = (0, _reactRouterDom.useNavigate)();
  var theme = (0, _styles.useTheme)();

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var _ref2 = (data === null || data === void 0 ? void 0 : data.val) || {},
      authorUid = _ref2.authorUid,
      _ref2$authorPhotoUrl = _ref2.authorPhotoUrl,
      authorPhotoUrl = _ref2$authorPhotoUrl === void 0 ? null : _ref2$authorPhotoUrl,
      _ref2$authorName = _ref2.authorName,
      authorName = _ref2$authorName === void 0 ? '' : _ref2$authorName,
      _ref2$message = _ref2.message,
      message = _ref2$message === void 0 ? '' : _ref2$message,
      type = _ref2.type,
      _ref2$location = _ref2.location,
      location = _ref2$location === void 0 ? '' : _ref2$location,
      image = _ref2.image,
      isSend = _ref2.isSend,
      isReceived = _ref2.isReceived,
      isRead = _ref2.isRead,
      scrollToBottom = _ref2.scrollToBottom,
      _ref2$created = _ref2.created,
      created = _ref2$created === void 0 ? '' : _ref2$created;

  var intl = (0, _reactIntl.useIntl)();
  var isMe = auth.uid === authorUid;

  var _useState = (0, _react.useState)(null),
      anchorEl = _useState[0],
      setAnchorEl = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      showMenu = _useState2[0],
      setShowMenu = _useState2[1];

  var open = Boolean(anchorEl);
  var db = (0, _database.getDatabase)();

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  var days = (0, _moment["default"])(created).diff((0, _moment["default"])(), 'days');
  (0, _react.useEffect)(function () {
    if (authorUid && auth.uid !== authorUid && !isRead) {
      var _db = (0, _database.getDatabase)();

      var updates = {};
      updates[path + "/" + uid] = true;
      updates["user_chats/" + auth.uid + "/" + authorUid + "/unread"] = null;
      (0, _database.update)((0, _database.ref)(_db), updates);
    }
  }, [path, uid, authorUid, auth, isRead]);
  var backgroundColor = isMe ? theme.palette.grey[500] : theme.palette.grey[300];
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, dateChanged && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '100%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      paddingTop: 10,
      paddingBottom: 10
    }
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_material.Chip, {
    size: "small",
    style: {
      fontSize: 10,
      color: 'grey',
      backgroundColor: theme.palette.grey[200]
    },
    label: "" + (created ? intl.formatRelativeTime(days, 'day', {
      numeric: 'auto'
    }) : undefined)
  }))), /*#__PURE__*/_react["default"].createElement(_material.Paper, {
    elevation: 1,
    onClick: function onClick() {
      setShowMenu(showMenu);
    },
    onMouseEnter: function onMouseEnter() {
      setShowMenu(true);
    },
    onMouseLeave: function onMouseLeave() {
      setShowMenu(false);
    },
    onDoubleClick: function onDoubleClick() {
      console.log('test');
    },
    style: {
      marginTop: userChanged ? 6 : 2,
      padding: 0,
      maxWidth: 320,
      alignSelf: isMe ? 'flex-end' : 'flex-start',
      borderRadius: userChanged ? isMe ? '6px 0px 6px 6px' : '0px 6px 6px 6px' : '6px 6px 6px 6px',
      backgroundColor: backgroundColor,
      color: isMe ? 'white' : 'black',
      whiteSpace: 'pre-wrap',
      overflowWrap: 'break-word'
    }
  }, showMenu && (authorUid === auth.uid || auth.isAdmin) && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      width: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      flex: 1
    }
  }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_material.IconButton, {
    style: {
      margin: 0,
      padding: 0
    },
    size: "small",
    "aria-label": "more",
    "aria-controls": "long-menu",
    "aria-haspopup": "true",
    onClick: handleClick
  }, /*#__PURE__*/_react["default"].createElement(_iconsMaterial.KeyboardArrowDown, null)), /*#__PURE__*/_react["default"].createElement(_material.Menu, {
    id: "long-menu",
    anchorEl: anchorEl,
    keepMounted: true,
    open: open,
    onClose: handleClose
  }, /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    key: 'delete',
    onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              handleClose();
              _context.next = 3;
              return (0, _database.set)((0, _database.ref)(db), path + "/" + uid, null);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))
  }, intl.formatMessage({
    id: 'delete',
    defaultMessage: 'Delete'
  }))))), !isMe && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      width: '100%',
      justifyContent: 'flex-start',
      paddingRight: 4,
      paddingLeft: 4,
      cursor: 'pointer'
    },
    onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (0, _database.update)((0, _database.ref)(db, "user_chats/" + auth.uid + "/" + authorUid), {
                displayName: authorName,
                photoURL: authorPhotoUrl
              });

            case 2:
              navigate("/chats/" + authorUid);

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }))
  }, /*#__PURE__*/_react["default"].createElement(_material.Typography, {
    variant: "caption",
    color: "secondary",
    style: {
      fontSize: 10,
      padding: 0,
      margin: 0
    }
  }, authorName)), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      padding: 4,
      paddingBottom: 0
    }
  }, type === 'text' && /*#__PURE__*/_react["default"].createElement(_reactLinkify["default"], {
    properties: {
      target: '_blank'
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.Typography, {
    variant: "body2"
  }, message)), type === 'image' && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_ImageViewer["default"], {
    style: {
      height: 'auto',
      maxWidth: 300,
      paddingTop: 0,
      cursor: 'pointer',
      borderRadius: 5
    },
    imageStyle: {
      maxWidth: '100%',
      padding: 0,
      position: 'relative',
      borderRadius: 5
    },
    onLoad: scrollToBottom,
    src: image,
    color: backgroundColor,
    alt: "chat_image"
  })), type === 'location' && /*#__PURE__*/_react["default"].createElement("img", {
    alt: "location",
    onClick: function onClick() {
      window.open(location, 'blank');
    },
    style: {
      height: 'auto',
      maxWidth: 300,
      paddingTop: 0,
      cursor: 'pointer',
      borderRadius: 5
    },
    src: "https://maps.googleapis.com/maps/api/staticmap?center=%7C" + location.lat + "," + getMapLoc(location).lng + "&zoom=14&size=300x300\n&markers=color:red%7Clabel:%7C" + getMapLoc(location).lat + "," + getMapLoc(location).lng + "\n&key=" + appConfig.googleMaps.apiKey
  })), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      width: '100%',
      justifyContent: 'flex-end',
      paddingRight: 4,
      paddingLeft: 4
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.Typography, {
    variant: "caption",
    style: {
      fontSize: 8,
      padding: 0,
      margin: 0,
      color: 'black'
    }
  }, created ? intl.formatTime(new Date(created)) : undefined), isSend && isReceived && /*#__PURE__*/_react["default"].createElement(_iconsMaterial.DoneAll, {
    style: {
      fontSize: 11,
      padding: 0,
      paddingLeft: 2,
      bottom: -2,
      color: isRead ? theme.palette.secondary.main : theme.palette.text.primary
    }
  }), isSend && !isReceived && /*#__PURE__*/_react["default"].createElement(_iconsMaterial.Done, {
    style: {
      fontSize: 11,
      padding: 0,
      paddingLeft: 2,
      bottom: -2,
      color: isRead ? theme.palette.secondary.main : theme.palette.text.primary
    }
  }))));
}

module.exports = exports.default;