"use strict";

exports.__esModule = true;
exports.AvatarImage = AvatarImage;

var _react = _interopRequireWildcard(require("react"));

var _material = require("@mui/material");

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _CameraAlt = _interopRequireDefault(require("@mui/icons-material/CameraAlt"));

var _Util = require("./Util");

var _reactFinalForm = require("react-final-form");

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _ImageUploadDialog = _interopRequireDefault(require("../../containers/ImageUploadDialog"));

var _excluded = ["name", "type", "fieldProps", "path"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function AvatarImage(props) {
  var _useState = (0, _react.useState)(false),
      isImageDialogOpen = _useState[0],
      setImageDialogOpen = _useState[1];

  var name = props.name,
      type = props.type,
      fieldProps = props.fieldProps,
      path = props.path,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Field, _extends({
    name: name,
    type: type,
    render: function render(_ref) {
      var input = _ref.input,
          meta = _ref.meta;
      var value = input.value,
          onChange = input.onChange;

      var handleImageChange = function handleImageChange(image) {
        onChange(image);
      };

      return /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          display: "flex",
          flexDirection: "column",
          justifyContent: "center",
          alignItems: "center"
        }
      }, /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
        style: {
          minWidth: 100,
          minHeight: 100
        },
        alt: "Picture",
        src: value
      }), /*#__PURE__*/_react["default"].createElement(_material.Box, {
        sx: {
          margin: 1
        }
      }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
        onClick: function onClick() {
          return setImageDialogOpen(true);
        },
        style: {},
        color: "primary",
        "aria-label": "save",
        size: "small"
      }, /*#__PURE__*/_react["default"].createElement(_CameraAlt["default"], null))), /*#__PURE__*/_react["default"].createElement(_ImageUploadDialog["default"], {
        isOpen: isImageDialogOpen,
        handleClose: function handleClose() {
          return setImageDialogOpen(false);
        },
        handleCropSubmit: handleImageChange,
        path: path
      }));
    }
  }, fieldProps));
}