"use strict";

exports.__esModule = true;
exports.KeyboardDatePicker = KeyboardDatePicker;

var _react = _interopRequireDefault(require("react"));

var _xDatePickers = require("@mui/x-date-pickers");

var _reactFinalForm = require("react-final-form");

var _Util = require("./Util");

var _TextField = _interopRequireDefault(require("@mui/material/TextField"));

var _excluded = ["name", "fieldProps"],
    _excluded2 = ["name", "onChange", "value"],
    _excluded3 = ["input", "formatValue", "meta", "dateFunsUtils", "locale", "showError"],
    _excluded4 = ["helperText"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function KeyboardDatePicker(props) {
  var name = props.name,
      fieldProps = props.fieldProps,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return _react["default"].createElement(_reactFinalForm.Field, Object.assign({
    name: name,
    render: function render(fieldRenderProps) {
      return _react["default"].createElement(KeyboardDatePickerWrapper, Object.assign({}, fieldRenderProps, rest));
    }
  }, fieldProps));
}

function KeyboardDatePickerWrapper(props) {
  var _props$input = props.input,
      name = _props$input.name,
      _onChange = _props$input.onChange,
      value = _props$input.value,
      restInput = _objectWithoutPropertiesLoose(_props$input, _excluded2),
      _props$formatValue = props.formatValue,
      formatValue = _props$formatValue === void 0 ? function (v) {
    if (v && v.isValid()) {
      return v.format();
    } else {
      return null; //v?._i
    }
  } : _props$formatValue,
      meta = props.meta,
      dateFunsUtils = props.dateFunsUtils,
      locale = props.locale,
      _props$showError = props.showError,
      showError = _props$showError === void 0 ? _Util.showErrorOnChange : _props$showError,
      rest = _objectWithoutPropertiesLoose(props, _excluded3);

  var error = meta.error,
      submitError = meta.submitError;
  var isError = showError({
    meta: meta
  });

  var helperText = rest.helperText,
      lessrest = _objectWithoutPropertiesLoose(rest, _excluded4);

  return _react["default"].createElement(_xDatePickers.DatePicker, Object.assign({
    disableToolbar: true,
    fullWidth: true,
    autoOk: true,
    helperText: isError ? error || submitError : helperText,
    error: isError,
    onChange: function onChange(v) {
      _onChange(formatValue(v));
    },
    name: name,
    value: value === "" ? null : value,
    inputProps: restInput,
    renderInput: function renderInput(params) {
      return /*#__PURE__*/_react["default"].createElement(_TextField["default"], params);
    }
  }, lessrest)), locale;
}