"use strict";

exports.__esModule = true;
exports.TextField = TextField;
exports.TextFieldWrapper = TextFieldWrapper;

var _react = _interopRequireDefault(require("react"));

var _material = require("@mui/material");

var _Util = require("./Util");

var _reactFinalForm = require("react-final-form");

var _excluded = ["name", "type", "fieldProps"],
    _excluded2 = ["name", "value", "type", "onChange", "onBlur", "onFocus"],
    _excluded3 = ["input", "meta", "required", "fullWidth", "helperText", "showError"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/*
const identity = (value) => value

const TextField = ({ fieldProps, ...rest }) => {
  return (
    <SourceField
      required
      fieldProps={{ parse: identity, ...fieldProps }}
      {...rest}
    />
  )
}

export { TextField }
export default TextField
*/
function TextField(props) {
  var name = props.name,
      type = props.type,
      fieldProps = props.fieldProps,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Field, _extends({
    name: name,
    type: type,
    render: function render(_ref) {
      var input = _ref.input,
          meta = _ref.meta;
      return /*#__PURE__*/_react["default"].createElement(TextFieldWrapper, _extends({
        input: input,
        meta: meta,
        name: name,
        type: type
      }, rest));
    }
  }, fieldProps));
}

function TextFieldWrapper(props) {
  var _props$input = props.input,
      name = _props$input.name,
      value = _props$input.value,
      type = _props$input.type,
      onChange = _props$input.onChange,
      onBlur = _props$input.onBlur,
      onFocus = _props$input.onFocus,
      restInput = _objectWithoutPropertiesLoose(_props$input, _excluded2),
      meta = props.meta,
      required = props.required,
      _props$fullWidth = props.fullWidth,
      fullWidth = _props$fullWidth === void 0 ? true : _props$fullWidth,
      helperText = props.helperText,
      _props$showError = props.showError,
      showError = _props$showError === void 0 ? _Util.showErrorOnChange : _props$showError,
      rest = _objectWithoutPropertiesLoose(props, _excluded3);

  var error = meta.error,
      submitError = meta.submitError;
  var isError = showError({
    meta: meta
  });
  return /*#__PURE__*/_react["default"].createElement(_material.TextField, _extends({
    fullWidth: fullWidth,
    helperText: isError ? error || submitError : helperText,
    error: isError,
    onChange: onChange,
    onBlur: onBlur,
    onFocus: onFocus,
    name: name,
    value: value,
    type: type,
    required: required,
    inputProps: _extends({
      required: required
    }, restInput)
  }, rest));
}