"use strict";

exports.__esModule = true;
exports.ErrorMessage = ErrorMessage;
exports.useFieldForErrors = exports.showErrorOnChange = exports.showErrorOnBlur = void 0;

var _react = _interopRequireDefault(require("react"));

var _material = require("@mui/material");

var _reactFinalForm = require("react-final-form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ErrorMessage(_ref) {
  var showError = _ref.showError,
      meta = _ref.meta,
      formHelperTextProps = _ref.formHelperTextProps,
      helperText = _ref.helperText;

  if (showError) {
    return _react["default"].createElement(_material.FormHelperText, Object.assign({}, formHelperTextProps), meta.error || meta.submitError);
  } else if (!!helperText) {
    return _react["default"].createElement(_material.FormHelperText, Object.assign({}, formHelperTextProps), helperText);
  } else {
    return _react["default"].createElement(_react["default"].Fragment, null);
  }
}

var config = {
  subscription: {
    error: true,
    submitError: true,
    dirtySinceLastSubmit: true,
    touched: true,
    modified: true
  }
};

var useFieldForErrors = function useFieldForErrors(name) {
  return (0, _reactFinalForm.useField)(name, config);
};

exports.useFieldForErrors = useFieldForErrors;

var showErrorOnChange = function showErrorOnChange(_ref2) {
  var _ref2$meta = _ref2.meta,
      submitError = _ref2$meta.submitError,
      dirtySinceLastSubmit = _ref2$meta.dirtySinceLastSubmit,
      error = _ref2$meta.error,
      touched = _ref2$meta.touched,
      modified = _ref2$meta.modified;
  return !!((submitError && !dirtySinceLastSubmit || error) && (touched || modified));
};

exports.showErrorOnChange = showErrorOnChange;

var showErrorOnBlur = function showErrorOnBlur(_ref3) {
  var _ref3$meta = _ref3.meta,
      submitError = _ref3$meta.submitError,
      dirtySinceLastSubmit = _ref3$meta.dirtySinceLastSubmit,
      error = _ref3$meta.error,
      touched = _ref3$meta.touched;
  return !!((submitError && !dirtySinceLastSubmit || error) && touched);
};

exports.showErrorOnBlur = showErrorOnBlur;