"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _ListItem = _interopRequireDefault(require("@mui/material/ListItem"));

var _ListItemText = _interopRequireDefault(require("@mui/material/ListItemText"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _Mail = _interopRequireDefault(require("@mui/icons-material/Mail"));

var _Star = _interopRequireDefault(require("@mui/icons-material/Star"));

var _ListItemAvatar = _interopRequireDefault(require("@mui/material/ListItemAvatar"));

var _Icons = require("../../components/Icons");

var _Badge = _interopRequireDefault(require("@mui/material/Badge"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@mui/material/ListItemSecondaryAction"));

var _Checkbox = _interopRequireDefault(require("@mui/material/Checkbox"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var getProviderIcon = function getProviderIcon(id) {
  var iconProps = {
    color: "primary",
    style: {
      height: 20,
      width: 20
    }
  };

  if (id === "google.com") {
    return /*#__PURE__*/_react["default"].createElement(_Icons.GoogleIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "facebook.com") {
    return /*#__PURE__*/_react["default"].createElement(_Icons.FacebookIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "github.com") {
    return /*#__PURE__*/_react["default"].createElement(_Icons.GitHubIcon, _extends({
      key: id
    }, iconProps));
  }

  if (id === "twitter.com") {
    return /*#__PURE__*/_react["default"].createElement(_Icons.TwitterIcon, _extends({
      key: id
    }, iconProps));
  }

  return /*#__PURE__*/_react["default"].createElement(_Mail["default"], _extends({
    key: id
  }, iconProps));
};

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style,
      _ref$admins = _ref.admins,
      admins = _ref$admins === void 0 ? [] : _ref$admins,
      _ref$isChecked = _ref.isChecked,
      isChecked = _ref$isChecked === void 0 ? false : _ref$isChecked,
      _ref$handleRowClick = _ref.handleRowClick,
      handleRowClick = _ref$handleRowClick === void 0 ? function () {} : _ref$handleRowClick,
      _ref$hasCheckbox = _ref.hasCheckbox,
      hasCheckbox = _ref$hasCheckbox === void 0 ? false : _ref$hasCheckbox;
  var _data$displayName = data.displayName,
      displayName = _data$displayName === void 0 ? "" : _data$displayName,
      key = data.key,
      photoURL = data.photoURL,
      _data$providerData = data.providerData,
      providerData = _data$providerData === void 0 ? [] : _data$providerData,
      icon = data.icon,
      secondaryText = data.secondaryText;
  var isAdmin = false;
  admins.map(function (a) {
    if (a.key === key) {
      isAdmin = true;
    }

    return a;
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    key: key,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
    button: true,
    alignItems: "flex-start",
    style: {
      height: 82
    },
    onClick: function onClick() {
      return handleRowClick(data);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemAvatar["default"], null, /*#__PURE__*/_react["default"].createElement(_Badge["default"], {
    invisible: !isAdmin,
    anchorOrigin: {
      vertical: "top",
      horizontal: "left"
    },
    badgeContent: /*#__PURE__*/_react["default"].createElement(_Star["default"], {
      style: {
        width: 15,
        padding: 0
      }
    }),
    color: "secondary"
  }, /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
    src: photoURL,
    style: {
      height: 45,
      width: 45
    }
  }, icon))), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
    primary: "" + displayName,
    secondary: providerData.length > 0 ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, providerData.map(function (p) {
      return getProviderIcon(p.providerId);
    })) : secondaryText
  }), hasCheckbox && /*#__PURE__*/_react["default"].createElement(_ListItemSecondaryAction["default"], null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    edge: "end",
    checked: !!isChecked,
    onClick: function onClick() {
      return handleRowClick(data);
    }
  }))), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    variant: "inset"
  }));
};

var _default = Row;
exports["default"] = _default;
module.exports = exports.default;