"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactIntl = require("react-intl");

var firebaseui = _interopRequireWildcard(require("firebaseui"));

var _auth = require("firebase/auth");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var authUi = null;
/*eslint-disable */

var AuthUI = function AuthUI(_ref) {
  var uiConfig = _ref.uiConfig;
  var intl = (0, _reactIntl.useIntl)();
  var locale = intl.locale;
  var auth = (0, _auth.getAuth)();
  var initAuth = (0, _react.useCallback)( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            try {
              if (!firebaseui.auth.AuthUI.getInstance()) {
                authUi = new firebaseui.auth.AuthUI(auth);
              } else {
                authUi = firebaseui.auth.AuthUI.getInstance();
              }
            } catch (err) {
              console.warn(err);
            }

            try {
              authUi.start('#firebaseui-auth', uiConfig);
            } catch (error) {
              console.warn(error);
            }

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), [locale]);
  (0, _react.useEffect)(function () {
    initAuth();
    return function () {
      try {
        if (authUi) {
          authUi.reset();
        }
      } catch (err) {
        console.warn(err);
      }
    };
  }, [initAuth, authUi]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      paddingTop: 35
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    key: "" + intl.locale,
    id: "firebaseui-auth"
  }));
};

var _default = AuthUI;
/*eslint-enable */

exports["default"] = _default;
module.exports = exports.default;