"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Input = _interopRequireDefault(require("@mui/material/Input"));

var _styles = require("@mui/material/styles");

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _Mic = _interopRequireDefault(require("@mui/icons-material/Mic"));

var _MyLocation = _interopRequireDefault(require("@mui/icons-material/MyLocation"));

var _CameraAlt = _interopRequireDefault(require("@mui/icons-material/CameraAlt"));

var _Send = _interopRequireDefault(require("@mui/icons-material/Send"));

var _reactIntl = require("react-intl");

var _IconButton = _interopRequireDefault(require("@mui/material/IconButton"));

var _Auth = require("base-shell/lib/providers/Auth");

var _location = require("../../utils/location");

var _material = require("@mui/material");

var _database = require("firebase/database");

var _storage = require("firebase/storage");

var _app = require("firebase/app");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _default(_ref) {
  var path = _ref.path;
  var theme = (0, _styles.useTheme)();
  var intl = (0, _reactIntl.useIntl)();

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useState = (0, _react.useState)(""),
      value = _useState[0],
      setValue = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      isUploading = _useState2[0],
      setUploading = _useState2[1];

  var db = (0, _database.getDatabase)();

  var uploadSelectedFile = function uploadSelectedFile(file) {
    if (file === null) {
      return;
    }

    if ((file.size / 1024 / 1024).toFixed(4) > 20) {
      //file larger than 10mb
      alert(intl.formatMessage({
        id: "max_file_size"
      }));
      return;
    }

    setUploading(true);
    var reader = new FileReader();
    var r = (0, _database.push)((0, _database.ref)(db, "/user_chat_messages/"));

    reader.onload = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(fileData) {
        var snap, downloadURL;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _storage.uploadString)((0, _storage.ref)((0, _storage.getStorage)((0, _app.getApp)()), "/user_chats/" + auth.uid + "/" + r.key + ".jpg"), fileData.target.result, "data_url");

              case 2:
                snap = _context.sent;
                _context.next = 5;
                return (0, _storage.getDownloadURL)(snap.ref);

              case 5:
                downloadURL = _context.sent;
                sendMessage({
                  type: "image",
                  message: "",
                  image: downloadURL,
                  key: r.key
                });
                setUploading(false);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }();

    reader.readAsDataURL(file);
  };

  var sendMessage = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(props) {
      var newMessage;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              newMessage = _extends({
                created: (0, _database.serverTimestamp)(),
                authorName: auth.displayName,
                authorUid: auth.uid,
                authorPhotoUrl: auth.photoURL,
                languageCode: intl.formatMessage({
                  id: "current_locale",
                  defaultMessage: "en-US"
                })
              }, props);
              console.log("path", path);
              console.log("newMessage", newMessage);
              _context2.next = 5;
              return (0, _database.set)((0, _database.push)((0, _database.ref)(db, "" + path)), newMessage);

            case 5:
              setValue("");

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function sendMessage(_x2) {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: "flex",
      padding: 4,
      paddingBottom: 8,
      alignItems: "center"
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      margin: 0,
      marginLeft: 8,
      marginRight: 8,
      paddingRight: 8,
      backgroundColor: theme.palette.grey[300],
      borderRadius: 22,
      height: "100%",
      flex: 1,
      display: "flex"
    }
  }, /*#__PURE__*/_react["default"].createElement(_Input["default"], {
    style: {
      height: 50,
      left: 15,
      color: "black"
    },
    multiline: true,
    rowsMax: "2",
    disableUnderline: true,
    fullWidth: true,
    autoFocus: true,
    value: value,
    autoComplete: "off",
    placeholder: intl.formatMessage({
      id: "write_message_hint",
      defaultMessage: "Write message"
    }),
    onChange: function onChange(e) {
      return setValue(e.target.value);
    },
    onKeyDown: function onKeyDown(e) {
      if (e.keyCode === 13 && value.trim() !== "") {
        e.preventDefault();
        sendMessage({
          type: "text",
          message: value
        });
      }
    },
    type: "Text"
  }), /*#__PURE__*/_react["default"].createElement("input", {
    style: {
      display: "none"
    },
    accept: "image/*",
    id: "icon-button-file",
    type: "file",
    onChange: function onChange(e) {
      uploadSelectedFile(e.target.files[0]);
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: "flex",
      alignItems: "center",
      justifyContent: "center"
    }
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("label", {
    htmlFor: "icon-button-file"
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    disabled: isUploading,
    color: "primary",
    "aria-label": "upload picture",
    component: "span",
    size: "small",
    edge: false
  }, isUploading && /*#__PURE__*/_react["default"].createElement(_material.CircularProgress, {
    color: "secondary",
    style: {
      width: 20,
      height: 20
    }
  }), !isUploading && /*#__PURE__*/_react["default"].createElement(_CameraAlt["default"], null))))), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    color: "primary",
    size: "small",
    onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var _yield$getLocation, coords, lat, _long;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return (0, _location.getLocation)();

            case 3:
              _yield$getLocation = _context3.sent;
              coords = _yield$getLocation.coords;
              lat = coords === null || coords === void 0 ? void 0 : coords.latitude;
              _long = coords === null || coords === void 0 ? void 0 : coords.longitude;
              sendMessage({
                type: "location",
                message: "",
                location: "https://www.google.com/maps/place/" + lat + "+" + _long + "/@" + lat + "," + _long,
                location_lat: lat,
                location_lng: _long
              });
              _context3.next = 12;
              break;

            case 10:
              _context3.prev = 10;
              _context3.t0 = _context3["catch"](0);

            case 12:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[0, 10]]);
    }))
  }, /*#__PURE__*/_react["default"].createElement(_MyLocation["default"], null))), /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    onClick: value !== "" ? function () {
      return sendMessage({
        type: "text",
        message: value
      });
    } : undefined,
    color: "secondary",
    size: "medium"
  }, value === "" && /*#__PURE__*/_react["default"].createElement(_Mic["default"], null), value !== "" && /*#__PURE__*/_react["default"].createElement(_Send["default"], null)));
}

module.exports = exports.default;