"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _react = _interopRequireWildcard(require("react"));

var _Lists = require("../../providers/Firebase/Lists");

var _ChatMessage = _interopRequireDefault(require("../../components/ChatMessage"));

var _Input = _interopRequireDefault(require("./Input"));

var _Chip = _interopRequireDefault(require("@mui/material/Chip"));

var _Scrollbar = _interopRequireDefault(require("material-ui-shell/lib/components/Scrollbar"));

var _styles = require("@mui/material/styles");

var _Chat = _interopRequireDefault(require("@mui/icons-material/Chat"));

var _reactIntl = require("react-intl");

var _database = require("firebase/database");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var step = 20;
var currentUser = null;
var currentDate = null;

function _default(_ref) {
  var path = _ref.path;
  var intl = (0, _reactIntl.useIntl)();
  var theme = (0, _styles.useTheme)();

  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      unwatchList = _useLists.unwatchList,
      clearList = _useLists.clearList;

  var _useState = (0, _react.useState)(step),
      size = _useState[0],
      setSize = _useState[1];

  var _useState2 = (0, _react.useState)(null),
      listEnd = _useState2[0],
      setlistEnd = _useState2[1];

  var alias = path + "_" + size;
  var messages = getList(alias);
  var scrollToBottom = (0, _react.useCallback)(function () {
    if (size === step) {
      var node = listEnd;

      if (node) {
        node.scrollIntoView({
          behavior: 'smooth'
        });
      }
    }
  }, [listEnd, size]);
  (0, _react.useEffect)(function () {
    if (path) {
      var messagesRef = (0, _database.query)((0, _database.ref)((0, _database.getDatabase)(), path), (0, _database.orderByKey)(), (0, _database.limitToLast)(size));
      watchList(messagesRef, alias);
      return function () {
        if (size === step) {
          unwatchList(alias);
        } else {
          clearList(alias);
        }
      };
    }
  }, [path, size, watchList, clearList, alias, unwatchList]);
  (0, _react.useEffect)(function () {
    scrollToBottom();
    setTimeout(function () {
      scrollToBottom();
    }, 1000);
  }, [path, listEnd, messages, scrollToBottom]);

  if (!path) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: '100%',
        height: '100%',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center'
      }
    }, /*#__PURE__*/_react["default"].createElement(_Chat["default"], {
      color: "disabled",
      style: {
        height: 150,
        width: 150
      }
    }));
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      flexGrow: 1,
      overflow: 'hidden'
    }
  }, /*#__PURE__*/_react["default"].createElement(_Scrollbar["default"], {
    style: {
      //backgroundColor: theme.palette.background.default,
      width: '100%'
    },
    renderView: function renderView(props) {
      return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
        style: _extends({}, props.style, {
          overflowX: 'hidden'
        })
      }));
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      paddingLeft: 8,
      paddingRight: 8
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      width: '100%',
      maxWidth: 500
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: 15
    }
  }), /*#__PURE__*/_react["default"].createElement(_Chip["default"], {
    label: intl.formatMessage({
      id: 'load_more_label',
      defaultMessage: 'more...'
    }),
    onClick: function onClick() {
      setSize(size + step);
    },
    size: "small",
    style: {
      width: 80,
      alignSelf: 'center',
      margin: 8,
      backgroundColor: theme.palette.grey[400]
    }
  }), messages.map(function (m) {
    var _ref2 = (m === null || m === void 0 ? void 0 : m.val) || {},
        _ref2$authorUid = _ref2.authorUid,
        authorUid = _ref2$authorUid === void 0 ? '' : _ref2$authorUid,
        _ref2$created = _ref2.created,
        created = _ref2$created === void 0 ? '' : _ref2$created;

    var stringDate = created ? new Date(created).toISOString().slice(0, 10) : '';
    var userChanged = authorUid !== currentUser;
    var dateChanged = currentDate !== stringDate;

    if (userChanged) {
      currentUser = authorUid;
    }

    if (dateChanged) {
      currentDate = stringDate;
    }

    return /*#__PURE__*/_react["default"].createElement(_ChatMessage["default"], {
      key: m.key,
      uid: m.key,
      message: m,
      path: path,
      userChanged: userChanged,
      dateChanged: dateChanged,
      scrollToBottom: scrollToBottom
    });
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      "float": 'left',
      clear: 'both'
    },
    ref: function ref(el) {
      setlistEnd(el);
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: 8
    }
  }))), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Input["default"], {
    path: path
  })));
}

module.exports = exports.default;