"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _react = _interopRequireWildcard(require("react"));

var _Config = require("base-shell/lib/providers/Config");

var _Auth = require("base-shell/lib/providers/Auth");

var _Provider = _interopRequireDefault(require("../../providers/Firebase/Paths/Provider"));

var _Provider2 = _interopRequireDefault(require("../../providers/Firebase/Lists/Provider"));

var _Provider3 = _interopRequireDefault(require("../../providers/Firebase/Docs/Provider"));

var _Provider4 = _interopRequireDefault(require("../../providers/Firebase/Cols/Provider"));

var _Provider5 = _interopRequireDefault(require("../../providers/Firebase/Messaging/Provider"));

var _Provider6 = _interopRequireDefault(require("../../providers/Firebase/Storage/Provider"));

var _app = require("firebase/app");

var _auth = require("firebase/auth");

var _LocalizationProvider = require("@mui/x-date-pickers/LocalizationProvider");

var _AdapterMoment = require("@mui/x-date-pickers/AdapterMoment");

var _Locale = require("base-shell/lib/providers/Locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _default(_ref) {
  var children = _ref.children;

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var auth = (0, _Auth.useAuth)();

  var _ref2 = appConfig || {},
      firebaseConfig = _ref2.firebase,
      _ref2$auth = _ref2.auth,
      authConfig = _ref2$auth === void 0 ? {} : _ref2$auth;

  var _ref3 = firebaseConfig || {},
      _ref3$prod = _ref3.prod,
      prod = _ref3$prod === void 0 ? {} : _ref3$prod,
      _ref3$dev = _ref3.dev,
      dev = _ref3$dev === void 0 ? {} : _ref3$dev;

  var _ref4 = authConfig || {},
      internalOnAuthStateChanged = _ref4.onAuthStateChanged;

  var _useLocale = (0, _Locale.useLocale)(),
      _useLocale$locale = _useLocale.locale,
      locale = _useLocale$locale === void 0 ? "en" : _useLocale$locale;

  if ((0, _app.getApps)().length === 0) {
    (0, _app.initializeApp)(process.env.NODE_ENV !== "production" ? dev.initConfig : prod.initConfig);
  }

  (0, _react.useEffect)(function () {
    var unsubscribe = (0, _auth.onAuthStateChanged)((0, _auth.getAuth)((0, _app.getApp)()), function (user) {
      if (_auth.onAuthStateChanged) {
        internalOnAuthStateChanged(user, auth);
      }
    });
    return function () {
      unsubscribe();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_Provider["default"], null, /*#__PURE__*/_react["default"].createElement(_Provider2["default"], null, /*#__PURE__*/_react["default"].createElement(_Provider3["default"], null, /*#__PURE__*/_react["default"].createElement(_Provider4["default"], null, /*#__PURE__*/_react["default"].createElement(_Provider6["default"], null, /*#__PURE__*/_react["default"].createElement(_Provider5["default"], null, /*#__PURE__*/_react["default"].createElement(_LocalizationProvider.LocalizationProvider, {
    dateAdapter: _AdapterMoment.AdapterMoment,
    adapterLocale: locale
  }, children)))))));
}

module.exports = exports.default;