"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactFinalForm = require("react-final-form");

var _Paths = require("../../providers/Firebase/Paths");

var _Auth = require("base-shell/lib/providers/Auth");

var _finalFormArrays = _interopRequireDefault(require("final-form-arrays"));

var _database = require("firebase/database");

var _excluded = ["uid", "path", "handleSubmit", "Form", "grants", "formProps", "initialValues", "parseValues", "setSubmit"],
    _excluded2 = ["handleSubmit", "submit"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FirebaseForm = function FirebaseForm(_ref) {
  var uid = _ref.uid,
      _ref$path = _ref.path,
      path = _ref$path === void 0 ? "none" : _ref$path,
      _ref$handleSubmit = _ref.handleSubmit,
      handleSubmit = _ref$handleSubmit === void 0 ? function () {} : _ref$handleSubmit,
      Form = _ref.Form,
      _ref$grants = _ref.grants,
      grants = _ref$grants === void 0 ? {} : _ref$grants,
      _ref$formProps = _ref.formProps,
      formProps = _ref$formProps === void 0 ? {} : _ref$formProps,
      _ref$initialValues = _ref.initialValues,
      initialValues = _ref$initialValues === void 0 ? {} : _ref$initialValues,
      _ref$parseValues = _ref.parseValues,
      parseValues = _ref$parseValues === void 0 ? function (v) {
    return v;
  } : _ref$parseValues,
      setSubmit = _ref.setSubmit,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _usePaths = (0, _Paths.usePaths)(),
      watchPath = _usePaths.watchPath,
      clearPath = _usePaths.clearPath,
      getPath = _usePaths.getPath;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _ref2 = auth || {},
      _ref2$isGranted = _ref2.isGranted,
      isGranted = _ref2$isGranted === void 0 ? function () {
    return false;
  } : _ref2$isGranted;

  var databasePath = path + "/" + uid;
  var data = getPath(databasePath) || initialValues;
  (0, _react.useEffect)(function () {
    if (uid) {
      watchPath(databasePath);
    }

    return function () {
      return clearPath(databasePath);
    };
  }, [path, watchPath, clearPath, databasePath, uid]);
  return /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Form, _extends({
    mutators: _extends({}, _finalFormArrays["default"]),
    keepDirtyOnReinitialize: true,
    onSubmit: /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(rawValues) {
        var newUid, values, snap;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                newUid = false;
                values = rawValues;

                if (parseValues) {
                  values = parseValues(values);
                }

                console.log("values", values);

                if (!uid) {
                  _context.next = 9;
                  break;
                }

                _context.next = 7;
                return (0, _database.set)((0, _database.ref)((0, _database.getDatabase)(), path + "/" + uid), values);

              case 7:
                _context.next = 19;
                break;

              case 9:
                if (!isGranted(auth, grants.create)) {
                  _context.next = 18;
                  break;
                }

                _context.next = 12;
                return (0, _database.push)((0, _database.ref)((0, _database.getDatabase)(), path), values);

              case 12:
                _context.next = 14;
                return _context.sent;

              case 14:
                snap = _context.sent;
                newUid = snap.key;
                _context.next = 19;
                break;

              case 18:
                return _context.abrupt("return");

              case 19:
                handleSubmit(values, newUid);

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }(),
    initialValues: data,
    render: function render(_ref4) {
      var handleSubmit = _ref4.handleSubmit,
          submit = _ref4.submit,
          r = _objectWithoutPropertiesLoose(_ref4, _excluded2);

      if (!submit && setSubmit) {
        setSubmit(function () {
          return handleSubmit;
        });
      }

      return /*#__PURE__*/_react["default"].createElement(Form, _extends({
        handleSubmit: handleSubmit
      }, r, formProps));
    }
  }, rest));
};

var _default = FirebaseForm;
exports["default"] = _default;
module.exports = exports.default;