"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Checkbox = _interopRequireDefault(require("@mui/material/Checkbox"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _ListItem = _interopRequireDefault(require("@mui/material/ListItem"));

var _ListItemIcon = _interopRequireDefault(require("@mui/material/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@mui/material/ListItemText"));

var _react = _interopRequireWildcard(require("react"));

var _VirtualList = _interopRequireDefault(require("material-ui-shell/lib/containers/VirtualList"));

var _Config = require("base-shell/lib/providers/Config");

var _Filter = require("material-ui-shell/lib/providers/Filter");

var _Lists = require("../../providers/Firebase/Lists");

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _default(_ref) {
  var grantsPath = _ref.grantsPath;

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var _ref2 = appConfig || {},
      authConfig = _ref2.auth;

  var _ref3 = authConfig || {},
      _ref3$grants = _ref3.grants,
      grants = _ref3$grants === void 0 ? [] : _ref3$grants;

  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getFirebaseList = _useLists.getList;

  var _useFilter = (0, _Filter.useFilter)(),
      getList = _useFilter.getList;

  var db = (0, _database.getDatabase)();
  var roleGrants = getFirebaseList(grantsPath);
  var list = getList('grants', grants.map(function (g) {
    return {
      name: g
    };
  }), [{
    name: 'name'
  }]);
  (0, _react.useEffect)(function () {
    watchList(grantsPath);
  }, [grantsPath, watchList]);

  var Row = function Row(_ref4) {
    var index = _ref4.index,
        style = _ref4.style,
        data = _ref4.data;
    var name = data.name;
    var isSelected = false;
    roleGrants.map(function (rg) {
      if (rg.key === name) {
        isSelected = true;
      }

      return rg;
    });
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: name + "_" + index,
      style: style
    }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
      button: true,
      alignItems: "flex-start",
      onClick: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _database.set)((0, _database.ref)(db, grantsPath + "/" + name), isSelected ? null : true);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))
    }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
      edge: "start",
      checked: isSelected,
      tabIndex: -1,
      disableRipple: true
    })), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
      primary: name,
      secondary: name
    })), /*#__PURE__*/_react["default"].createElement(_Divider["default"], null));
  };

  return /*#__PURE__*/_react["default"].createElement(_VirtualList["default"], {
    list: list,
    name: "grants",
    listProps: {
      itemSize: 72
    },
    Row: Row
  });
}

module.exports = exports.default;