"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _Backdrop = _interopRequireDefault(require("@mui/material/Backdrop"));

var _Fade = _interopRequireDefault(require("@mui/material/Fade"));

var _Modal = _interopRequireDefault(require("@mui/material/Modal"));

var _react = _interopRequireWildcard(require("react"));

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _Close = _interopRequireDefault(require("@mui/icons-material/Close"));

var _Slide = _interopRequireDefault(require("@mui/material/Slide"));

var _excluded = ["src"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ImageViewer = function ImageViewer(_ref) {
  var src = _ref.src,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      open = _useState[0],
      setOpen = _useState[1];

  var handleOpen = function handleOpen() {
    setOpen(true);
  };

  var handleClose = function handleClose() {
    setOpen(false);
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("img", _extends({
    src: src,
    onClick: handleOpen
  }, rest)), /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    "aria-labelledby": "transition-modal-title",
    "aria-describedby": "transition-modal-description",
    open: open,
    onClose: handleClose,
    onEscapeKeyDown: handleClose,
    closeAfterTransition: true,
    BackdropComponent: _Backdrop["default"],
    BackdropProps: {
      timeout: 500
    },
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, /*#__PURE__*/_react["default"].createElement(_Fade["default"], {
    "in": open
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      maxHeight: '70%',
      maxWidth: '90%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      top: 50,
      left: 0,
      right: 0,
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      zIndex: 9999999
    }
  }, /*#__PURE__*/_react["default"].createElement(_Slide["default"], {
    direction: "down",
    "in": open,
    mountOnEnter: true,
    unmountOnExit: true
  }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    onClick: handleClose,
    color: "secondary",
    "aria-label": "close"
  }, /*#__PURE__*/_react["default"].createElement(_Close["default"], null)))), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      width: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement("img", {
    color: "transparent",
    iconContainerStyle: {
      border: 'none'
    },
    animationDuration: 0,
    style: {
      height: 'auto',
      width: 'auto',
      paddingTop: 0
    },
    imageStyle: {
      maxWidth: '100%',
      maxHeight: '100%',
      minHeight: '80%',
      width: 'auto',
      height: 'auto',
      padding: 0,
      position: 'relative',
      borderRadius: 5
    },
    src: src
  }))))));
};

var _default = ImageViewer;
exports["default"] = _default;
module.exports = exports.default;