"use strict";

exports.__esModule = true;
exports["default"] = FormPage;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Delete = _interopRequireDefault(require("@mui/icons-material/Delete"));

var _IconButton = _interopRequireDefault(require("@mui/material/IconButton"));

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page"));

var _react = _interopRequireWildcard(require("react"));

var _Save = _interopRequireDefault(require("@mui/icons-material/Save"));

var _reactRouterDom = require("react-router-dom");

var _Paths = require("../../providers/Firebase/Paths");

var _Question = require("material-ui-shell/lib/providers/Dialogs/Question");

var _Auth = require("base-shell/lib/providers/Auth");

var _FirebaseForm = _interopRequireDefault(require("../../containers/FirebaseForm"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function FormPage(props) {
  var uid = props.uid,
      _props$path = props.path,
      path = _props$path === void 0 ? "none" : _props$path,
      _props$getPageProps = props.getPageProps,
      getPageProps = _props$getPageProps === void 0 ? function () {} : _props$getPageProps,
      _props$handleDelete = props.handleDelete,
      handleDelete = _props$handleDelete === void 0 ? function () {} : _props$handleDelete,
      _props$deleteDialogPr = props.deleteDialogProps,
      deleteDialogProps = _props$deleteDialogPr === void 0 ? {} : _props$deleteDialogPr,
      _props$grants = props.grants,
      grants = _props$grants === void 0 ? {} : _props$grants,
      _props$initialValues = props.initialValues,
      initialValues = _props$initialValues === void 0 ? {} : _props$initialValues,
      _props$useSave = props.useSave,
      useSave = _props$useSave === void 0 ? true : _props$useSave,
      _props$useDelete = props.useDelete,
      useDelete = _props$useDelete === void 0 ? true : _props$useDelete,
      _props$alwaysAllowSav = props.alwaysAllowSave,
      alwaysAllowSave = _props$alwaysAllowSav === void 0 ? false : _props$alwaysAllowSav,
      _props$alwaysAllowDel = props.alwaysAllowDelete,
      alwaysAllowDelete = _props$alwaysAllowDel === void 0 ? false : _props$alwaysAllowDel;
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useQuestions = (0, _Question.useQuestions)(),
      openDialog = _useQuestions.openDialog;

  var _usePaths = (0, _Paths.usePaths)(),
      getPath = _usePaths.getPath;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useState = (0, _react.useState)(false),
      submit = _useState[0],
      setSubmit = _useState[1];

  var db = (0, _database.getDatabase)();

  var _ref = auth || {},
      _ref$isGranted = _ref.isGranted,
      isGranted = _ref$isGranted === void 0 ? function () {
    return false;
  } : _ref$isGranted;

  var databasePath = path + "/" + uid;
  var data = getPath(databasePath, {}) || initialValues;

  var openDeleteDialog = function openDeleteDialog() {
    openDialog(_extends({
      handleAction: function () {
        var _handleAction = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(handleClose) {
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return (0, _database.set)((0, _database.ref)(db, path + "/" + uid), null);

                case 2:
                  handleClose();
                  handleDelete();

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function handleAction(_x) {
          return _handleAction.apply(this, arguments);
        }

        return handleAction;
      }()
    }, deleteDialogProps));
  };

  return /*#__PURE__*/_react["default"].createElement(_Page["default"], _extends({
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    appBarContent: /*#__PURE__*/_react["default"].createElement("div", null, useSave && /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: !isGranted(auth, grants.create) && !alwaysAllowSave,
      color: "inherit",
      onClick: function onClick(e) {
        submit(e);
      }
    }, /*#__PURE__*/_react["default"].createElement(_Save["default"], null)), useDelete && /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: !uid || !isGranted(auth, grants["delete"]) && !alwaysAllowDelete,
      color: "inherit",
      onClick: function onClick() {
        openDeleteDialog();
      }
    }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null)))
  }, getPageProps({
    values: data,
    submit: submit
  })), /*#__PURE__*/_react["default"].createElement(_FirebaseForm["default"], _extends({
    setSubmit: setSubmit,
    submit: submit
  }, props)));
}

module.exports = exports.default;