"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _Add = _interopRequireDefault(require("@mui/icons-material/Add"));

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _ListPage = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/ListPage"));

var _react = _interopRequireWildcard(require("react"));

var _Auth = require("base-shell/lib/providers/Auth");

var _Lists = require("../../providers/Firebase/Lists");

var _useMediaQuery = _interopRequireDefault(require("@mui/material/useMediaQuery"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Page = function Page(_ref) {
  var _ref$fields = _ref.fields,
      fields = _ref$fields === void 0 ? [] : _ref$fields,
      _ref$path = _ref.path,
      path = _ref$path === void 0 ? 'none' : _ref$path,
      _ref$getRef = _ref.getRef,
      getRef = _ref$getRef === void 0 ? false : _ref$getRef,
      Row = _ref.Row,
      _ref$listProps = _ref.listProps,
      listProps = _ref$listProps === void 0 ? {} : _ref$listProps,
      _ref$getPageProps = _ref.getPageProps,
      _getPageProps = _ref$getPageProps === void 0 ? function () {} : _ref$getPageProps,
      _ref$onCreateClick = _ref.onCreateClick,
      onCreateClick = _ref$onCreateClick === void 0 ? function () {} : _ref$onCreateClick,
      createGrant = _ref.createGrant,
      listPageProps = _ref.listPageProps,
      _ref$reverse = _ref.reverse,
      reverse = _ref$reverse === void 0 ? false : _ref$reverse,
      _ref$disableCreate = _ref.disableCreate,
      disableCreate = _ref$disableCreate === void 0 ? false : _ref$disableCreate,
      _ref$fabLabel = _ref.fabLabel,
      fabLabel = _ref$fabLabel === void 0 ? null : _ref$fabLabel;

  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      isListLoading = _useLists.isListLoading,
      unwatchList = _useLists.unwatchList;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _ref2 = auth || {},
      _ref2$isGranted = _ref2.isGranted,
      isGranted = _ref2$isGranted === void 0 ? function () {
    return false;
  } : _ref2$isGranted;

  var matches = (0, _useMediaQuery["default"])('(min-width:400px)');
  (0, _react.useEffect)(function () {
    var ref = path;

    if (getRef) {
      ref = getRef();
    }

    watchList(ref, path);
    return function () {
      return unwatchList(path);
    };
  }, [getRef, path, watchList, unwatchList]);
  var source = getList(path).map(function (_ref3) {
    var key = _ref3.key,
        val = _ref3.val;
    return _extends({
      key: key
    }, val);
  });
  var list = reverse ? [].concat(source).reverse() : source;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_ListPage["default"], _extends({
    name: path,
    list: list,
    fields: fields,
    Row: Row,
    listProps: listProps,
    getPageProps: function getPageProps(list) {
      return _extends({
        isLoading: isListLoading(path)
      }, _getPageProps(list));
    }
  }, listPageProps)), isGranted(auth, createGrant) && !disableCreate && /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    variant: matches && fabLabel ? 'extended' : undefined,
    color: "secondary",
    style: {
      position: 'absolute',
      bottom: 18,
      right: 18
    },
    onClick: onCreateClick
  }, /*#__PURE__*/_react["default"].createElement(_Add["default"], null), " ", matches ? fabLabel : null));
};

var _default = Page;
exports["default"] = _default;
module.exports = exports.default;