"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _Chat = _interopRequireDefault(require("../../containers/Chat"));

var _Chat2 = _interopRequireDefault(require("@mui/icons-material/Chat"));

var _Group = _interopRequireDefault(require("@mui/icons-material/Group"));

var _Security = _interopRequireDefault(require("@mui/icons-material/Security"));

var _Info = _interopRequireDefault(require("@mui/icons-material/Info"));

var _People = _interopRequireDefault(require("@mui/icons-material/People"));

var _Person = _interopRequireDefault(require("@mui/icons-material/Person"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _ListItem = _interopRequireDefault(require("@mui/material/ListItem"));

var _ListItemAvatar = _interopRequireDefault(require("@mui/material/ListItemAvatar"));

var _ListItemText = _interopRequireDefault(require("@mui/material/ListItemText"));

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page"));

var _react = _interopRequireWildcard(require("react"));

var _VirtualList = _interopRequireDefault(require("material-ui-shell/lib/containers/VirtualList"));

var _useMediaQuery = _interopRequireDefault(require("@mui/material/useMediaQuery"));

var _Auth = require("base-shell/lib/providers/Auth");

var _reactRouterDom = require("react-router-dom");

var _reactIntl = require("react-intl");

var _Lists = require("../../providers/Firebase/Lists");

var _styles = require("@mui/material/styles");

var _Theme = require("material-ui-shell/lib/providers/Theme");

var _Messaging = require("../../providers/Firebase/Messaging");

var _MoreHoriz = _interopRequireDefault(require("@mui/icons-material/MoreHoriz"));

var _Delete = _interopRequireDefault(require("@mui/icons-material/Delete"));

var _History = _interopRequireDefault(require("@mui/icons-material/History"));

var _material = require("@mui/material");

var _ListItemIcon = _interopRequireDefault(require("@mui/material/ListItemIcon"));

var _moment = _interopRequireDefault(require("moment"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style;
  var navigate = (0, _reactRouterDom.useNavigate)();
  var intl = (0, _reactIntl.useIntl)();

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useAppTheme = (0, _Theme.useTheme)(),
      isRTL = _useAppTheme.isRTL;

  var _data$displayName = data.displayName,
      displayName = _data$displayName === void 0 ? '' : _data$displayName,
      _data$lastMessage = data.lastMessage,
      lastMessage = _data$lastMessage === void 0 ? '' : _data$lastMessage,
      key = data.key,
      photoURL = data.photoURL,
      _data$path = data.path,
      path = _data$path === void 0 ? '' : _data$path,
      _data$lastCreated = data.lastCreated,
      lastCreated = _data$lastCreated === void 0 ? '' : _data$lastCreated;

  var _React$useState = _react["default"].useState(null),
      anchorEl = _React$useState[0],
      setAnchorEl = _React$useState[1];

  var _useParams = (0, _reactRouterDom.useParams)(),
      _useParams$uid = _useParams.uid,
      uid = _useParams$uid === void 0 ? '' : _useParams$uid;

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  var handleDeleteChat = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _database.set)((0, _database.ref)((0, _database.getDatabase)(), "user_chats/" + auth.uid + "/" + key), null);

            case 2:
              handleClose();

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleDeleteChat() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleMarkAsUnread = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (0, _database.set)((0, _database.ref)((0, _database.getDatabase)(), "user_chats/" + auth.uid + "/" + key + "/unread"), 1);

            case 2:
              handleClose();

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleMarkAsUnread() {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react["default"].createElement("div", {
    key: key,
    style: _extends({}, style, {
      direction: isRTL ? 'rtl' : 'ltr'
    })
  }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
    button: true,
    selected: key === uid,
    alignItems: "flex-start",
    style: {
      height: 72
    },
    onClick: function onClick() {
      navigate("/chats/" + key);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemAvatar["default"], null, /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
    src: photoURL
  }, path !== '' && /*#__PURE__*/_react["default"].createElement(_Group["default"], null), path === '' && /*#__PURE__*/_react["default"].createElement(_Person["default"], null))), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
    primary: displayName,
    secondary: /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        maxWidth: 170,
        whiteSpace: 'nowrap'
      }
    }, lastMessage)
  }), /*#__PURE__*/_react["default"].createElement(_material.ListItemSecondaryAction, null, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column'
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.IconButton, {
    size: "small",
    "aria-controls": "simple-menu",
    "aria-haspopup": "true",
    onClick: handleClick
  }, /*#__PURE__*/_react["default"].createElement(_MoreHoriz["default"], null)), /*#__PURE__*/_react["default"].createElement(_material.Menu, {
    id: "simple-menu",
    anchorEl: anchorEl,
    keepMounted: true,
    open: Boolean(anchorEl),
    onClose: handleClose
  }, path !== '' && /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    onClick: function onClick() {
      navigate("/group_chat/" + key);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_Info["default"], null)), intl.formatMessage({
    id: 'info',
    defaultMessage: 'Info'
  })), path !== '' && /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    onClick: function onClick() {
      navigate("/edit_members/" + key);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_People["default"], null)), intl.formatMessage({
    id: 'members',
    defaultMessage: 'Members'
  })), path !== '' && /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    onClick: function onClick() {
      navigate("/edit_admins/" + key);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_Security["default"], null)), intl.formatMessage({
    id: 'admins',
    defaultMessage: 'Admins'
  })), /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    onClick: handleDeleteChat
  }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null)), path === '' && intl.formatMessage({
    id: 'delete_chat',
    defaultMessage: 'Delete chat'
  }), path !== '' && intl.formatMessage({
    id: 'delete_group_chat',
    defaultMessage: 'Delete group chat'
  })), /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    onClick: handleMarkAsUnread
  }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_History["default"], null)), intl.formatMessage({
    id: 'martk_as_unread',
    defaultMessage: 'Mark as unread'
  }))), /*#__PURE__*/_react["default"].createElement(_material.Typography, {
    variant: "caption"
  }, (0, _moment["default"])(lastCreated || (0, _moment["default"])()).format('HH:mm')), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: 5
    }
  })))), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    variant: "inset"
  }));
};

function _default() {
  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useParams2 = (0, _reactRouterDom.useParams)(),
      _useParams2$uid = _useParams2.uid,
      uid = _useParams2$uid === void 0 ? '' : _useParams2$uid;

  var _useAuth2 = (0, _Auth.useAuth)(),
      auth = _useAuth2.auth;

  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      unwatchList = _useLists.unwatchList;

  var _useMessaging = (0, _Messaging.useMessaging)(),
      requestPermission = _useMessaging.requestPermission;

  var theme = (0, _styles.useTheme)();
  var matches = (0, _useMediaQuery["default"])(theme.breakpoints.up('sm'));
  var chatsPath = "user_chats/" + auth.uid;
  (0, _react.useEffect)(function () {
    watchList(chatsPath);
    requestPermission();
    return function () {
      return unwatchList(chatsPath);
    };
  }, [chatsPath, unwatchList, watchList, requestPermission]);
  var chats = getList(chatsPath).map(function (c) {
    return _extends({
      key: c.key
    }, c.val);
  });
  var showChats = matches || !uid;
  var showMessages = matches || uid;
  var currentChat = chats.find(function (c) {
    return c.key === uid;
  });
  var path = (currentChat === null || currentChat === void 0 ? void 0 : currentChat.path) || (uid ? "user_chat_messages/" + auth.uid + "/" + uid : false);
  var title = intl.formatMessage({
    id: 'chats',
    defaultMessage: 'Chats'
  });

  if (currentChat) {
    title = currentChat === null || currentChat === void 0 ? void 0 : currentChat.displayName;
    /*
    title = (
      <div>
        <Avatar>
          <Avatar src={currentChat?.photoURL}>
            {currentChat?.path !== '' && <Group />}
            {currentChat?.path === '' && <Person />}
          </Avatar>
        </Avatar>
        <Typography>{currentChat?.displayName}</Typography>
      </div>
    )
    */
  }

  return /*#__PURE__*/_react["default"].createElement(_Page["default"], {
    onBackClick: !matches && uid ? function () {
      navigate('/chats', {
        replace: true
      });
    } : undefined,
    pageTitle: title
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '100%',
      display: 'flex'
    }
  }, showChats && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: matches ? 300 : '100%',
      height: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement(_VirtualList["default"], {
    list: chats,
    name: 'user_chats',
    listProps: {
      itemSize: 72
    },
    Row: Row
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      bottom: 15,
      right: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    color: "secondary",
    onClick: function onClick() {
      navigate('/create_chat');
    }
  }, /*#__PURE__*/_react["default"].createElement(_Chat2["default"], null)))), showMessages && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/_react["default"].createElement(_Chat["default"], {
    path: path
  }))));
}

module.exports = exports.default;