"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Lists = require("../../providers/Firebase/Lists");

var _ListPage = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/ListPage"));

var _reactIntl = require("react-intl");

var _reactRouterDom = require("react-router-dom");

var _Auth = require("base-shell/lib/providers/Auth");

var _UserRow = _interopRequireDefault(require("../../components/UserRow"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default() {
  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      clearList = _useLists.clearList,
      isListLoading = _useLists.isListLoading;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useParams = (0, _reactRouterDom.useParams)(),
      uid = _useParams.uid;

  var groupAdminsPath = "group_chats/" + uid + "/admins";
  var db = (0, _database.getDatabase)();
  (0, _react.useEffect)(function () {
    watchList('users');
    watchList('admins');
    watchList(groupAdminsPath);
    return function () {
      clearList(groupAdminsPath);
    };
  }, [watchList, clearList, groupAdminsPath]);
  var admins = getList('admins');
  var members = getList(groupAdminsPath);
  var list = getList('users').map(function (_ref) {
    var key = _ref.key,
        val = _ref.val;
    return _extends({
      key: key
    }, val);
  }).filter(function (u) {
    return u.key !== auth.uid;
  });

  var isChecked = function isChecked(key) {
    return members.find(function (m) {
      return m.key === key;
    });
  };

  var handleRowClick = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(user) {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _database.set)((0, _database.ref)(db, groupAdminsPath).child(user.key), isChecked(user.key) ? null : true);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleRowClick(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_ListPage["default"], {
    name: "users",
    list: list,
    Row: function Row(p) {
      return /*#__PURE__*/_react["default"].createElement(_UserRow["default"], _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick,
        hasCheckbox: true,
        isChecked: isChecked(p.data.key)
      }));
    },
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: 'edit_admins',
          defaultMessage: 'Edit admins'
        }),
        isLoading: isListLoading('users'),
        onBackClick: function onBackClick() {
          navigate(-1);
        }
      };
    }
  }));
}

module.exports = exports.default;