"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Lists = require("../../providers/Firebase/Lists");

var _Paths = require("../../providers/Firebase/Paths");

var _ListPage = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/ListPage"));

var _reactIntl = require("react-intl");

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _ArrowForward = _interopRequireDefault(require("@mui/icons-material/ArrowForward"));

var _reactRouterDom = require("react-router-dom");

var _Auth = require("base-shell/lib/providers/Auth");

var _TextField = _interopRequireDefault(require("@mui/material/TextField"));

var _material = require("@mui/material");

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page"));

var _UserRow = _interopRequireDefault(require("../../components/UserRow"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default() {
  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList,
      isListLoading = _useLists.isListLoading;

  var _usePaths = (0, _Paths.usePaths)(),
      watchPath = _usePaths.watchPath,
      getPath = _usePaths.getPath,
      clearPath = _usePaths.clearPath;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useParams = (0, _reactRouterDom.useParams)(),
      _useParams$uid = _useParams.uid,
      uid = _useParams$uid === void 0 ? false : _useParams$uid;

  var _useState = (0, _react.useState)({}),
      selected = _useState[0],
      setSelected = _useState[1];

  var _useState2 = (0, _react.useState)(uid !== false ? 1 : 0),
      step = _useState2[0],
      setStep = _useState2[1];

  var db = (0, _database.getDatabase)();

  var _ref = getPath("group_chats/" + uid, {}) || {},
      _ref$name = _ref.name,
      currentName = _ref$name === void 0 ? '' : _ref$name;

  var _useState3 = (0, _react.useState)(''),
      name = _useState3[0],
      setName = _useState3[1];

  (0, _react.useEffect)(function () {
    watchList('users');
    watchList('admins');

    if (uid) {
      watchPath("group_chats/" + uid);
    }

    return function () {
      if (uid) {
        clearPath("group_chats/" + uid);
      }
    };
  }, [watchList, uid, watchPath, clearPath]);
  (0, _react.useEffect)(function () {
    setName(currentName);
  }, [currentName]);
  var admins = getList('admins');
  var list = getList('users').map(function (_ref2) {
    var key = _ref2.key,
        val = _ref2.val;
    return _extends({
      key: key
    }, val);
  }).filter(function (u) {
    return u.key !== auth.uid;
  });

  var handleRowClick = function handleRowClick(user) {
    var key = user.key;

    if (!selected[key]) {
      var _extends2;

      setSelected(_extends({}, selected, (_extends2 = {}, _extends2[key] = user, _extends2)));
    } else {
      var removed = selected[key],
          rest = _objectWithoutPropertiesLoose(selected, [key].map(_toPropertyKey));

      setSelected(rest);
    }
  };

  var handleNextClick = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _members, members, snap;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(step === 0)) {
                _context.next = 4;
                break;
              }

              setStep(1);
              _context.next = 20;
              break;

            case 4:
              if (!uid) {
                _context.next = 10;
                break;
              }

              _context.next = 7;
              return (0, _database.update)((0, _database.ref)(db, "group_chats/" + uid), {
                name: name
              });

            case 7:
              navigate('/chats');
              _context.next = 20;
              break;

            case 10:
              members = (_members = {}, _members[auth.uid] = true, _members);
              Object.entries(selected).map(function (e) {
                var key = e[0];
                members[key] = true;
                return e;
              });
              _context.next = 14;
              return (0, _database.push)((0, _database.ref)(db, "group_chats"));

            case 14:
              snap = _context.sent;
              _context.next = 17;
              return (0, _database.set)((0, _database.ref)(db, "group_chats/" + snap.key + "/admins/" + auth.uid), true);

            case 17:
              _context.next = 19;
              return (0, _database.update)((0, _database.ref)(db, "group_chats/" + snap.key), {
                members: members,
                name: name
              });

            case 19:
              navigate('/chats');

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleNextClick() {
      return _ref3.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, step === 0 && /*#__PURE__*/_react["default"].createElement(_ListPage["default"], {
    name: "users",
    list: list,
    Row: function Row(p) {
      return /*#__PURE__*/_react["default"].createElement(_UserRow["default"], _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick,
        hasCheckbox: true,
        isChecked: selected[p.data.key]
      }));
    },
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: 'select_users',
          defaultMessage: 'Select Users'
        }),
        isLoading: isListLoading('users'),
        onBackClick: function onBackClick() {
          navigate(-1);
        }
      };
    }
  }), step === 1 && /*#__PURE__*/_react["default"].createElement(_Page["default"], {
    pageTitle: intl.formatMessage({
      id: 'set_name',
      defaultMessage: 'Set name'
    })
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '100%',
      height: '100%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.Paper, {
    style: {
      padding: 18
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
    name: "name",
    placeholder: intl.formatMessage({
      id: 'group_name',
      defaultMessage: 'Group name'
    }),
    value: name,
    onChange: function onChange(e) {
      return setName(e.target.value);
    }
  })))), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      bottom: 15,
      right: 35
    }
  }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    disabled: step === 1 && name === '',
    color: "secondary",
    onClick: handleNextClick
  }, /*#__PURE__*/_react["default"].createElement(_ArrowForward["default"], null))));
}

module.exports = exports.default;