"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _CameraAlt = _interopRequireDefault(require("@mui/icons-material/CameraAlt"));

var _Delete = _interopRequireDefault(require("@mui/icons-material/Delete"));

var _Fab = _interopRequireDefault(require("@mui/material/Fab"));

var _InputBase = _interopRequireDefault(require("@mui/material/InputBase"));

var _NotificationsOff = _interopRequireDefault(require("@mui/icons-material/NotificationsOff"));

var _Notifications = _interopRequireDefault(require("@mui/icons-material/Notifications"));

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/Page"));

var _Paper = _interopRequireDefault(require("@mui/material/Paper"));

var _react = _interopRequireWildcard(require("react"));

var _Save = _interopRequireDefault(require("@mui/icons-material/Save"));

var _Typography = _interopRequireDefault(require("@mui/material/Typography"));

var _Zoom = _interopRequireDefault(require("@mui/material/Zoom"));

var _material = require("@mui/material");

var _Auth = require("base-shell/lib/providers/Auth");

var _Config = require("base-shell/lib/providers/Config");

var _reactIntl = require("react-intl");

var _Question = require("material-ui-shell/lib/providers/Dialogs/Question");

var _ImageUploadDialog = _interopRequireDefault(require("../../containers/ImageUploadDialog"));

var _Icons = require("../../components/Icons");

var _auth = require("firebase/auth");

var _database = require("firebase/database");

var _Messaging = require("../../providers/Firebase/Messaging");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var uuid = function uuid() {
  var url = URL.createObjectURL(new Blob());

  var _url$toString$split$r = url.toString().split('/').reverse(),
      id = _url$toString$split$r[0];

  URL.revokeObjectURL(url);
  return id;
};

var MyAccount = function MyAccount() {
  var intl = (0, _reactIntl.useIntl)();

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var _ref = appConfig || {},
      firebaseConfig = _ref.firebase;

  var _ref2 = firebaseConfig || {},
      firebaseuiProps = _ref2.firebaseuiProps;

  var _ref3 = firebaseuiProps || {},
      _ref3$signInOptions = _ref3.signInOptions,
      signInOptions = _ref3$signInOptions === void 0 ? [] : _ref3$signInOptions;

  var _useQuestions = (0, _Question.useQuestions)(),
      openDialog = _useQuestions.openDialog;

  var database = (0, _database.getDatabase)();

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth,
      updateAuth = _useAuth.updateAuth;

  var _ref4 = auth || {},
      _ref4$photoURL = _ref4.photoURL,
      currentPhoroURL = _ref4$photoURL === void 0 ? '' : _ref4$photoURL,
      _ref4$displayName = _ref4.displayName,
      currentDisplayName = _ref4$displayName === void 0 ? '' : _ref4$displayName,
      _ref4$email = _ref4.email,
      email = _ref4$email === void 0 ? '' : _ref4$email,
      _ref4$notificationsDi = _ref4.notificationsDisabled,
      notificationsDisabled = _ref4$notificationsDi === void 0 ? false : _ref4$notificationsDi;

  var _useState = (0, _react.useState)(currentDisplayName),
      displayName = _useState[0],
      setDisplayName = _useState[1];

  var _useState2 = (0, _react.useState)(currentPhoroURL),
      photoURL = _useState2[0],
      setPhotoURL = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      isImageDialogOpen = _useState3[0],
      setImageDialogOpen = _useState3[1];

  var _useMessaging = (0, _Messaging.useMessaging)(),
      requestPermission = _useMessaging.requestPermission;

  var hasChange = displayName !== currentDisplayName || photoURL !== currentPhoroURL;

  var handleImageChange = function handleImageChange(image) {
    setPhotoURL(image);
  };

  var getProviderIcon = function getProviderIcon(id) {
    if (id === 'google.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.GoogleIcon, null);
    }

    if (id === 'facebook.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.FacebookIcon, null);
    }

    if (id === 'github.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.GitHubIcon, null);
    }

    if (id === 'twitter.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.TwitterIcon, null);
    }

    return null;
  };

  var getProvider = function getProvider(provider) {
    if (provider.indexOf('facebook') > -1) {
      return new _auth.FacebookAuthProvider();
    }

    if (provider.indexOf('github') > -1) {
      return new _auth.GithubAuthProvider();
    }

    if (provider.indexOf('google') > -1) {
      return new _auth.GoogleAuthProvider();
    }

    if (provider.indexOf('twitter') > -1) {
      return new _auth.TwitterAuthProvider();
    }

    if (provider.indexOf('phone') > -1) {
      return new _auth.PhoneAuthProvider();
    }

    throw new Error('Provider is not supported!');
  };

  var handleSave = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              (0, _auth.updateProfile)((0, _auth.getAuth)().currentUser, {
                displayName: displayName,
                photoURL: photoURL
              });
              updateAuth(_extends({}, auth, {
                displayName: displayName,
                photoURL: photoURL
              }));
              _context.next = 4;
              return (0, _auth.updateCurrentUser)((0, _auth.getAuth)(), (0, _auth.getAuth)().currentUser);

            case 4:
              _context.next = 6;
              return (0, _auth.reload)((0, _auth.getAuth)().currentUser);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSave() {
      return _ref5.apply(this, arguments);
    };
  }();

  var isLinkedWithProvider = function isLinkedWithProvider(provider) {
    try {
      return auth && auth.providerData && auth.providerData.find(function (p) {
        return p.providerId === provider;
      }) !== undefined;
    } catch (e) {
      return false;
    }
  };

  var linkUserWithPopup = function linkUserWithPopup(p) {
    var provider = getProvider(p);
    (0, _auth.linkWithPopup)((0, _auth.getAuth)().currentUser, provider).then(function () {
      updateAuth(_extends({}, auth, (0, _auth.getAuth)().currentUser));
    }, function (e) {
      console.warn(e);
    });
  };

  var openDeleteDialog = function openDeleteDialog() {
    openDialog({
      title: intl.formatMessage({
        id: 'delete_account_dialog_title',
        defaultMessage: 'Delete Account?'
      }),
      message: intl.formatMessage({
        id: 'delete_account_dialog_message',
        defaultMessage: 'This Account and all related data to it will be deleted permanently. Do you want to proceed with the deletion?'
      }),
      action: intl.formatMessage({
        id: 'delete_account_dialog_action',
        defaultMessage: 'DELETE ACCOUNT'
      }),
      handleAction: handleDelete
    });
  };

  var openReauthenticateDialog = function openReauthenticateDialog() {
    openDialog({
      title: intl.formatMessage({
        id: 'reauthenticate_account_dialog_title',
        defaultMessage: 'Reauthentication required'
      }),
      message: intl.formatMessage({
        id: 'reauthenticate_account_dialog_message',
        defaultMessage: 'To ensure that you are the real owner of this account a reauthentication is required. For that you need to logout and login into the application. By pressing the REAUTHENTICATION button you will be logged out automaticaly. After you login afain you can delete your account!'
      }),
      action: intl.formatMessage({
        id: 'reauthenticate_account_dialog_action',
        defaultMessage: 'REAUTHENTICATE'
      }),
      handleAction: function handleAction(hc) {
        (0, _auth.getAuth)().currentUser.signOut();
        hc();
      }
    });
  };

  var handleDelete = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(handleClose) {
      var code;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return (0, _auth.deleteUser)((0, _auth.getAuth)().currentUser);

            case 3:
              _context2.next = 9;
              break;

            case 5:
              _context2.prev = 5;
              _context2.t0 = _context2["catch"](0);
              code = _context2.t0.code;

              if (code === 'auth/requires-recent-login') {
                openReauthenticateDialog();
              }

            case 9:
              handleClose();

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 5]]);
    }));

    return function handleDelete(_x) {
      return _ref6.apply(this, arguments);
    };
  }();

  var handleDisableNotifications = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return (0, _database.set)((0, _database.ref)(database, "disable_notifications/" + auth.uid), true);

            case 2:
              _context3.next = 4;
              return (0, _database.remove)((0, _database.ref)(database, "notification_tokens/" + auth.uid));

            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function handleDisableNotifications() {
      return _ref8.apply(this, arguments);
    };
  }();

  var handleEnableNotifications = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return (0, _database.set)((0, _database.ref)(database, "disable_notifications/" + auth.uid), null);

            case 2:
              updateAuth(_extends({}, auth, {
                notificationsDisabled: false
              }));
              requestPermission();
              window.location.reload();

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function handleEnableNotifications() {
      return _ref9.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/_react["default"].createElement(_Page["default"], {
    pageTitle: intl.formatMessage({
      id: 'my_account',
      defaultMessage: 'My Account'
    })
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
    elevation: 3,
    style: {
      position: 'relative',
      //width: 300,
      //height: 300,
      borderRadius: 18,
      display: 'flex',
      justifyContent: 'flex-start',
      flexDirection: 'column',
      alignItems: 'center'
    }
  }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    size: "medium",
    style: {
      position: 'absolute',
      top: 30,
      right: -16
    },
    onClick: notificationsDisabled ? handleEnableNotifications : handleDisableNotifications,
    color: "primary",
    "aria-label": "notifications"
  }, !notificationsDisabled && /*#__PURE__*/_react["default"].createElement(_NotificationsOff["default"], null), notificationsDisabled && /*#__PURE__*/_react["default"].createElement(_Notifications["default"], null)), /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    size: "medium",
    style: {
      position: 'absolute',
      bottom: 40,
      right: -16
    },
    onClick: openDeleteDialog,
    color: "secondary",
    "aria-label": "delete"
  }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null)), /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    onClick: function onClick() {
      return setImageDialogOpen(true);
    },
    style: {
      position: 'absolute',
      zIndex: 99,
      top: 50,
      marginRight: -60
    },
    color: "primary",
    "aria-label": "save",
    size: "small"
  }, /*#__PURE__*/_react["default"].createElement(_CameraAlt["default"], null)), /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
    style: {
      width: 120,
      height: 120,
      marginTop: -40
    },
    alt: "User Picture",
    src: photoURL
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      flexDirection: 'column',
      marginTop: 18,
      marginBottom: 18
    }
  }, /*#__PURE__*/_react["default"].createElement(_InputBase["default"], {
    value: displayName,
    onChange: function onChange(e) {
      return setDisplayName(e.target.value);
    },
    inputProps: {
      'aria-label': 'naked',
      style: {
        fontSize: 26,
        fontWeight: 'bold',
        textAlign: 'center'
      }
    }
  }), /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h6"
  }, email), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      margin: 18,
      display: 'flex',
      alignItems: 'center'
    }
  }, signInOptions.map(function (so) {
    return getProviderIcon(so) ? /*#__PURE__*/_react["default"].createElement(_material.IconButton, {
      disabled: isLinkedWithProvider(so),
      color: "primary",
      key: so,
      onClick: function onClick() {
        return linkUserWithPopup(so);
      }
    }, getProviderIcon(so)) : null;
  }))), /*#__PURE__*/_react["default"].createElement(_Zoom["default"], {
    "in": hasChange
  }, /*#__PURE__*/_react["default"].createElement(_Fab["default"], {
    onClick: handleSave,
    style: {
      marginBottom: -20
    },
    color: "primary",
    "aria-label": "save"
  }, /*#__PURE__*/_react["default"].createElement(_Save["default"], null)))), /*#__PURE__*/_react["default"].createElement(_ImageUploadDialog["default"], {
    isOpen: isImageDialogOpen,
    handleClose: function handleClose() {
      return setImageDialogOpen(false);
    },
    handleCropSubmit: handleImageChange,
    path: "users/" + auth.uid + "/" + uuid() + ".jpeg"
  })));
};

var _default = MyAccount;
exports["default"] = _default;
module.exports = exports.default;