"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _reactIntl = require("react-intl");

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/Page"));

var _reactRouterDom = require("react-router-dom");

var _Tab = _interopRequireDefault(require("@mui/material/Tab"));

var _Tabs = _interopRequireDefault(require("@mui/material/Tabs"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _AccountBox = _interopRequireDefault(require("@mui/icons-material/AccountBox"));

var _Save = _interopRequireDefault(require("@mui/icons-material/Save"));

var _Delete = _interopRequireDefault(require("@mui/icons-material/Delete"));

var _Lock = _interopRequireDefault(require("@mui/icons-material/Lock"));

var _GrantsList = _interopRequireDefault(require("../../containers/GrantsList"));

var _Zoom = _interopRequireDefault(require("@mui/material/Zoom"));

var _SearchField = _interopRequireDefault(require("material-ui-shell/lib/components/SearchField"));

var _Filter = require("material-ui-shell/lib/providers/Filter");

var _FirebaseForm = _interopRequireDefault(require("../../containers/FirebaseForm"));

var _Role = _interopRequireDefault(require("../../components/Forms/Role"));

var _IconButton = _interopRequireDefault(require("@mui/material/IconButton"));

var _Auth = require("base-shell/lib/providers/Auth");

var _Question = require("material-ui-shell/lib/providers/Dialogs/Question");

var _database = require("firebase/database");

var _Box = _interopRequireDefault(require("@mui/material/Box"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var path = 'roles';
var singular = 'role';

function _default() {
  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useParams = (0, _reactRouterDom.useParams)(),
      uid = _useParams.uid,
      _useParams$tab = _useParams.tab,
      tab = _useParams$tab === void 0 ? 'main' : _useParams$tab;

  var _useFilter = (0, _Filter.useFilter)(),
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch;

  var _getFilter = getFilter(tab),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var _useQuestions = (0, _Question.useQuestions)(),
      openDialog = _useQuestions.openDialog;

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _auth$isGranted = auth.isGranted,
      isGranted = _auth$isGranted === void 0 ? function () {
    return false;
  } : _auth$isGranted;
  var _search$value = search.value,
      searchValue = _search$value === void 0 ? '' : _search$value;
  var submit;

  var setSubmit = function setSubmit(s) {
    submit = s;
  };

  var grantsPath = "role_grants/" + uid;

  var openDeleteDialog = function openDeleteDialog() {
    openDialog({
      handleAction: function () {
        var _handleAction = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(handleClose) {
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return (0, _database.set)((0, _database.ref)((0, _database.getDatabase)(), path + "/" + uid), null);

                case 2:
                  handleClose();
                  navigate("/" + path);

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function handleAction(_x) {
          return _handleAction.apply(this, arguments);
        }

        return handleAction;
      }(),
      title: intl.formatMessage({
        id: "delete_" + singular + "_dialog_title",
        defaultMessage: 'Delete Role?'
      }),
      message: intl.formatMessage({
        id: "delete_" + singular + "_dialog_message",
        defaultMessage: 'Role will be deleted permanently?'
      }),
      action: intl.formatMessage({
        id: "delete_" + singular + "_dialog_action",
        defaultMessage: 'DELETE ROLE'
      })
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_Page["default"], {
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    pageTitle: intl.formatMessage({
      id: 'role',
      defaultMessage: 'Role'
    }),
    appBarContent: /*#__PURE__*/_react["default"].createElement("div", null, tab === 'main' && /*#__PURE__*/_react["default"].createElement(_Zoom["default"], {
      key: tab,
      "in": tab === 'main'
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: !uid && !isGranted(auth, "create_" + singular) || !isGranted(auth, "edit_" + singular),
      color: "inherit",
      onClick: function onClick(e) {
        return submit(e);
      }
    }, /*#__PURE__*/_react["default"].createElement(_Save["default"], null)), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: !uid || !isGranted(auth, "delete_" + singular),
      color: "inherit",
      onClick: function onClick() {
        openDeleteDialog();
      }
    }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null)))), tab !== 'main' && /*#__PURE__*/_react["default"].createElement(_Zoom["default"], {
      key: tab,
      "in": tab !== 'main'
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_SearchField["default"], {
      initialValue: searchValue,
      onChange: function onChange(v) {
        setSearch(tab, v);
      }
    })))),
    tabs: /*#__PURE__*/_react["default"].createElement(_Box["default"], null, /*#__PURE__*/_react["default"].createElement(_Tabs["default"], {
      value: tab,
      onChange: function onChange(e, t) {
        navigate("/roles/" + uid + "/" + t, {
          replace: true
        });
      },
      centered: true
    }, /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
      value: "main",
      icon: /*#__PURE__*/_react["default"].createElement(_AccountBox["default"], {
        color: "inherit"
      })
    }), /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
      value: "grants",
      icon: /*#__PURE__*/_react["default"].createElement(_Lock["default"], null)
    })), /*#__PURE__*/_react["default"].createElement(_Divider["default"], null))
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '100%',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '100%'
    }
  }, tab === 'main' && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement(_FirebaseForm["default"], {
    path: "" + path,
    uid: uid,
    setSubmit: setSubmit,
    handleSubmit: function handleSubmit(values, newUid) {
      if (newUid) {
        navigate("/" + path + "/" + newUid, {
          replace: true
        });
      } else {
        navigate("/" + path);
      }
    },
    Form: _Role["default"]
  })), tab === 'grants' && /*#__PURE__*/_react["default"].createElement(_GrantsList["default"], {
    grantsPath: grantsPath
  }))));
}

module.exports = exports.default;