"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _AccountBox = _interopRequireDefault(require("@mui/icons-material/AccountBox"));

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _ListItem = _interopRequireDefault(require("@mui/material/ListItem"));

var _ListItemAvatar = _interopRequireDefault(require("@mui/material/ListItemAvatar"));

var _ListItemText = _interopRequireDefault(require("@mui/material/ListItemText"));

var _react = _interopRequireDefault(require("react"));

var _Page = require("../../containers/Page");

var _reactRouterDom = require("react-router-dom");

var _reactIntl = require("react-intl");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var fields = [{
  name: 'name',
  label: 'Name'
}, {
  name: 'description',
  label: 'Description'
}];

var Row = function Row(_ref) {
  var data = _ref.data,
      index = _ref.index,
      style = _ref.style;
  var _data$name = data.name,
      name = _data$name === void 0 ? '' : _data$name,
      _data$description = data.description,
      description = _data$description === void 0 ? '' : _data$description,
      key = data.key;
  var navigate = (0, _reactRouterDom.useNavigate)();
  return /*#__PURE__*/_react["default"].createElement("div", {
    key: key,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
    button: true,
    alignItems: "flex-start",
    style: {
      height: 72
    },
    onClick: function onClick() {
      navigate("/roles/" + key + "/main");
    }
  }, /*#__PURE__*/_react["default"].createElement(_ListItemAvatar["default"], null, /*#__PURE__*/_react["default"].createElement(_Avatar["default"], null, /*#__PURE__*/_react["default"].createElement(_AccountBox["default"], null))), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
    primary: name,
    secondary: description
  })), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    variant: "inset"
  }));
};

function _default() {
  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();
  return /*#__PURE__*/_react["default"].createElement(_Page.ListPage, {
    fields: fields,
    path: "roles",
    createGrant: "create_role",
    Row: Row,
    listProps: {
      itemSize: 72
    },
    getPageProps: function getPageProps() {
      return {
        pageTitle: intl.formatMessage({
          id: 'roles',
          defaultMessage: 'Roles'
        })
      };
    },
    onCreateClick: function onCreateClick() {
      navigate('/create_role');
    }
  });
}

module.exports = exports.default;