"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _Avatar = _interopRequireDefault(require("@mui/material/Avatar"));

var _Paper = _interopRequireDefault(require("@mui/material/Paper"));

var _react = _interopRequireWildcard(require("react"));

var _Typography = _interopRequireDefault(require("@mui/material/Typography"));

var _material = require("@mui/material");

var _reactIntl = require("react-intl");

var _Icons = require("../../components/Icons");

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/Page"));

var _Paths = require("../../providers/Firebase/Paths");

var _Lists = require("../../providers/Firebase/Lists");

var _reactRouterDom = require("react-router-dom");

var _Box = _interopRequireDefault(require("@mui/material/Box"));

var _Tab = _interopRequireDefault(require("@mui/material/Tab"));

var _Tabs = _interopRequireDefault(require("@mui/material/Tabs"));

var _AccountBox = _interopRequireDefault(require("@mui/icons-material/AccountBox"));

var _Lock = _interopRequireDefault(require("@mui/icons-material/Lock"));

var _Person = _interopRequireDefault(require("@mui/icons-material/Person"));

var _Email = _interopRequireDefault(require("@mui/icons-material/Email"));

var _GrantsList = _interopRequireDefault(require("../../containers/GrantsList"));

var _RolesList = _interopRequireDefault(require("../../containers/RolesList"));

var _Zoom = _interopRequireDefault(require("@mui/material/Zoom"));

var _SearchField = _interopRequireDefault(require("material-ui-shell/lib/components/SearchField"));

var _Filter = require("material-ui-shell/lib/providers/Filter");

var _FormControlLabel = _interopRequireDefault(require("@mui/material/FormControlLabel"));

var _Switch = _interopRequireDefault(require("@mui/material/Switch"));

var _database = require("firebase/database");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _default() {
  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _usePaths = (0, _Paths.usePaths)(),
      watchPath = _usePaths.watchPath,
      getPath = _usePaths.getPath;

  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList;

  var _useParams = (0, _reactRouterDom.useParams)(),
      uid = _useParams.uid,
      _useParams$tab = _useParams.tab,
      tab = _useParams$tab === void 0 ? 'main' : _useParams$tab;

  var _useFilter = (0, _Filter.useFilter)(),
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch;

  var _getFilter = getFilter(tab),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var _search$value = search.value,
      searchValue = _search$value === void 0 ? '' : _search$value;
  var grantsPath = "user_grants/" + uid;
  var rolesPath = "user_roles/" + uid;

  var getProviderIcon = function getProviderIcon(id) {
    if (id === 'password') {
      return /*#__PURE__*/_react["default"].createElement(_Email["default"], null);
    }

    if (id === 'google.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.GoogleIcon, null);
    }

    if (id === 'facebook.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.FacebookIcon, null);
    }

    if (id === 'github.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.GitHubIcon, null);
    }

    if (id === 'twitter.com') {
      return /*#__PURE__*/_react["default"].createElement(_Icons.TwitterIcon, null);
    }

    return null;
  };

  var path = "users/" + uid;
  (0, _react.useEffect)(function () {
    watchPath(path);
    watchList('admins'); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [path]);
  var user = getPath(path, {});
  var admins = getList('admins');

  var _ref = user || {},
      _ref$photoURL = _ref.photoURL,
      photoURL = _ref$photoURL === void 0 ? '' : _ref$photoURL,
      _ref$displayName = _ref.displayName,
      displayName = _ref$displayName === void 0 ? '' : _ref$displayName,
      _ref$email = _ref.email,
      email = _ref$email === void 0 ? '' : _ref$email,
      _ref$providerData = _ref.providerData,
      providerData = _ref$providerData === void 0 ? [] : _ref$providerData;

  var isAdmin = false;
  admins.map(function (a) {
    if (a.key === uid) {
      isAdmin = true;
    }

    return a;
  });
  return /*#__PURE__*/_react["default"].createElement(_Page["default"], {
    onBackClick: function onBackClick() {
      navigate(-1);
    },
    pageTitle: intl.formatMessage({
      id: 'user',
      defaultMessage: 'User'
    }),
    appBarContent: /*#__PURE__*/_react["default"].createElement("div", null, tab !== 'main' && /*#__PURE__*/_react["default"].createElement(_Zoom["default"], {
      key: tab,
      "in": tab !== 'main'
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_SearchField["default"], {
      initialValue: searchValue,
      onChange: function onChange(v) {
        setSearch(tab, v);
      }
    })))),
    tabs: /*#__PURE__*/_react["default"].createElement(_Box["default"], null, /*#__PURE__*/_react["default"].createElement(_Tabs["default"], {
      value: tab,
      onChange: function onChange(e, t) {
        navigate("/users/" + uid + "/" + t, {
          replace: true
        });
      },
      centered: true
    }, /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
      value: "main",
      icon: /*#__PURE__*/_react["default"].createElement(_Person["default"], {
        className: "material-icons"
      })
    }), /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
      value: "roles",
      icon: /*#__PURE__*/_react["default"].createElement(_AccountBox["default"], {
        className: "material-icons"
      })
    }), /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
      value: "grants",
      icon: /*#__PURE__*/_react["default"].createElement(_Lock["default"], {
        className: "material-icons"
      })
    })), /*#__PURE__*/_react["default"].createElement(_material.Divider, null))
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '100%',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: '100%'
    }
  }, tab === 'main' && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
    elevation: 3,
    style: {
      position: 'relative',
      //width: 300,
      //height: 300,
      borderRadius: 18,
      display: 'flex',
      justifyContent: 'flex-start',
      flexDirection: 'column',
      alignItems: 'center',
      padding: 18,
      minWidth: 250
    }
  }, /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
    style: {
      width: 120,
      height: 120,
      marginTop: -70
    },
    alt: "User Picture",
    src: photoURL
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      flexDirection: 'column',
      marginTop: 18,
      marginBottom: 18
    }
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h4"
  }, displayName), /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h6"
  }, email), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      margin: 18,
      display: 'flex',
      alignItems: 'center'
    }
  }, providerData.map(function (so) {
    return getProviderIcon(so.providerId) ? /*#__PURE__*/_react["default"].createElement(_material.IconButton, {
      color: "primary",
      key: so
    }, getProviderIcon(so.providerId)) : null;
  })), /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], {
    control: /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      checked: isAdmin,
      onChange: function onChange() {
        try {
          (0, _database.set)((0, _database.ref)((0, _database.getDatabase)(), "admins/" + uid), isAdmin ? null : true);
        } catch (error) {
          console.warn(error);
        }
      },
      name: "checkedA"
    }),
    label: intl.formatMessage({
      id: 'administrator',
      defaultMessage: 'Administrator'
    })
  })))), tab === 'roles' && /*#__PURE__*/_react["default"].createElement(_RolesList["default"], {
    path: rolesPath
  }), tab === 'grants' && /*#__PURE__*/_react["default"].createElement(_GrantsList["default"], {
    grantsPath: grantsPath
  }))));
}

module.exports = exports.default;