"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Lists = require("../../providers/Firebase/Lists");

var _ListPage = _interopRequireDefault(require("material-ui-shell/lib/containers/Page/ListPage"));

var _reactIntl = require("react-intl");

var _reactRouterDom = require("react-router-dom");

var _UserRow = _interopRequireDefault(require("../../components/UserRow"));

var _Filter = require("material-ui-shell/lib/providers/Filter");

var _firestore = require("firebase/firestore");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var fields = [{
  name: "displayName",
  label: "Name"
}];

function _default() {
  var _useLists = (0, _Lists.useLists)(),
      watchList = _useLists.watchList,
      getList = _useLists.getList;

  var intl = (0, _reactIntl.useIntl)();
  var navigate = (0, _reactRouterDom.useNavigate)();

  var _useState = (0, _react.useState)([]),
      list = _useState[0],
      setList = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      isLoading = _useState2[0],
      setLoading = _useState2[1];

  var _useFilter = (0, _Filter.useFilter)(),
      getFilter = _useFilter.getFilter;

  var _getFilter = getFilter("users"),
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search;

  var searchValue = search.value;
  var runSearch = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var db, ref, q, snap, tempLlist;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);
              db = (0, _firestore.getFirestore)();
              ref = (0, _firestore.collection)(db, "users");
              q = (0, _firestore.query)(ref, (0, _firestore.where)("search", "array-contains", searchValue.toLowerCase() || ""));
              _context.next = 6;
              return (0, _firestore.getDocs)(q);

            case 6:
              snap = _context.sent;
              tempLlist = [];
              snap.forEach(function (doc) {
                tempLlist.push(_extends({
                  key: doc.id
                }, doc.data()));
              });
              setList(tempLlist);
              setLoading(false);

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
  }, [searchValue]);
  (0, _react.useEffect)(function () {
    if (searchValue && searchValue !== "") {
      runSearch();
    } else {
      setList([]);
    }
  }, [runSearch, searchValue]);
  (0, _react.useEffect)(function () {
    watchList("admins");
  }, [watchList]);
  var admins = getList("admins");

  var handleRowClick = function handleRowClick(data) {
    console.log("data", data);
    navigate("/users/" + data.key);
  };

  return /*#__PURE__*/_react["default"].createElement(_ListPage["default"], {
    name: "users",
    list: list,
    fields: fields,
    Row: function Row(p) {
      return /*#__PURE__*/_react["default"].createElement(_UserRow["default"], _extends({}, p, {
        admins: admins,
        handleRowClick: handleRowClick
      }));
    },
    disableFilter: true,
    listProps: {
      itemSize: 82
    },
    getPageProps: function getPageProps(list) {
      return {
        pageTitle: intl.formatMessage({
          id: "users_page",
          defaultMessage: "Users {count}"
        }, {
          count: list.length
        }),
        isLoading: isLoading
      };
    }
  });
}

module.exports = exports.default;